subroutine begg_ds(n,poly,myeigre,myeigim) 

implicit none
 integer, intent(in) :: n
 real(kind(1d0)), intent(in) :: poly(n) 
 real(kind(1d0)), intent(out) :: myeigre(n),myeigim(n) 


real(kind(1d0)) :: g1(n),g2(n),h1(n),h2(n),p(n),q(n),beta(n),oldp(n)
real(kind(1d0)) :: sigma(n-1),gamma1(n-1),gamma2(n-1),diagonals(n),subdiag(n-1)
real(kind(1d0)) :: newp(n),newq(n),ptau(n),qtau(n),sigmatau(n),gtau1(n),gtau2(n)
real(kind(1d0)) :: b11(n-1),b12(n-1),b21(n-1),b22(n-1),V11(n-1),V12(n-1),V21(n-1),V22(n-1)
real(kind(1d0)) :: Vtau11(n-1),Vtau12(n-1),Vtau21(n-1),Vtau22(n-1)
real(kind(1d0)) :: QQ11(n-1),QQ12(n-1),QQ13(n-1),QQ21(n-1),QQ22(n-1),QQ23(n-1),QQ31(n-1),QQ32(n-1),QQ33(n-1)
real(kind(1d0)) :: newV11(n-1),newV12(n-1),newV21(n-1),newV22(n-1),auxAA(3,3)
real(kind(1d0)) :: F11(n-1),F12(n-1),F13(n-1),F21(n-1),F22(n-1),F23(n-1),F31(n-1),F32(n-1),F33(n-1)
real(kind(1d0)) :: newF11(n-1),newF12(n-1),newF13(n-1),newF21(n-1),newF22(n-1),newF23(n-1),newF31(n-1),newF32(n-1),newF33(n-1)
   real(kind(1d0)) :: Ftau11(n-1),Ftau12(n-1),Ftau13(n-1),Ftau21(n-1),Ftau22(n-1),Ftau23(n-1),Ftau31(n-1),Ftau32(n-1),Ftau33(n-1)
   real(kind(1d0)) :: Giv(2,2),MM(2,3),auxMM(2,3),x(2),y(2),ZZ(2,2),auxV(2,2),aux1,aux2,aux3,nrc
   real(kind(1d0)) :: bulgethree(3,3),nrs,na_final(2,2),Vhat(4,4),Fhat(5,5),auxtwo(2,2),oauxtwo(2,2)
   real(kind(1d0)) :: WW(3,3),DD(4,4),auxvec(2),a_final(2,2),a_initial(2,2),nrm(3),bb(2,2),auxp(5),Gv(2,2),GG(3,3)
   real(kind(1d0)) :: w1,normA,threshold,our_time,maxdiffeR,maxdiffeI,random_prod,random_sum,rtdisc,det,tr
   real(kind(1d0)) :: Xa(3,4),Xb(3,4),HH(3,3),Ya13,Ya31,Ya32,Ya23,Yb(3,3),Za(2,3),Zb(2,3),s,ys,w2
   real(kind(1d0)) :: lastsmallQ(2,2), lastbulge(2,3),auxF(5,5),auxQC(4,4),auxOC(5,5),auxthree(3,3),auxfour(4,4),auxsix(6,6)
   real(kind(1d0)) :: W(4,4),D(5,5),bulgenorm,auxpnorm,oaux44(4,4),aux32(3,2),aux34(3,4)
   real(kind(1d0)) :: sub25(2,5),sub63(6,3),sub54(5,4),sub46(4,6),sub52(5,2),sub36(3,6),oauxthree(3,3)
   real(kind(1d0)) :: subHH(3,3), subauxF(3,5),subsubauxF(2,5),subsubauxQC(3,4),subauxOC(3,5)
   real(kind(1d0)) :: subW(4,4),sub23(2,3),sub32(3,2),sub34(3,4),subD(5,5),vec2(2),vec3(3),aux22(2,2),aux33(3,3),aux44(4,4)
   real(kind(1d0)) :: sub42(4,2),sub24(2,4),sub35(3,5),sub53(5,3),sub43(4,3),cs,cn,af11,af12,af21,af22
   
   integer :: i,j,k,kp1,kp2,m,nm1,nm2,defl_size,random_flag,lmo
   integer :: iterations(n)
   real(kind(1d0)),allocatable :: lastmatrix(:,:)

   nm1=n-1
   nm2=n-2
  
  
!************* SETUP *************************
   
   normA=sqrt(sum(poly*poly)+nm1)  ! Frobenius norm of companion matrix
   threshold=min(50,n)*normA*epsilon(1.d0)
!threshold=normA*epsilon(1.d0)
   write(*,*) "Norm(A) = ",normA
   write(*,*) "Threshold = ",threshold
   defl_size=nm1;
   do i=1,n
      iterations(i)=0
   enddo
   random_flag=0  ! flag for random shift 

   !*************************************************
   ! Initialization of F, V, p, q.
   !*************************************************
   
   ! Store permuted identity matrices in F:
   !do i=1,(n-3)
      F11=0.d0
      F13=0.d0
      F22=0.d0
      F23=0.d0
      F31=0.d0
      F32=0.d0
      F21=1.d0
      F12=1.d0
      F33=1.d0
   !enddo
   F11(nm2)=0.d0
   F12(nm2)=0.d0
   F22(nm2)=0.d0
   F23(nm2)=0.d0
   F31(nm2)=0.d0
   F33(nm2)=0.d0
   F13(nm2)=1.d0
   F21(nm2)=1.d0
   F32(nm2)=1.d0
   
   F12(nm1)=0.d0
   F13(nm1)=0.d0
   F21(nm1)=0.d0
   F23(nm1)=0.d0
   F31(nm1)=0.d0
   F32(nm1)=0.d0
   F11(nm1)=1.d0
   F22(nm1)=1.d0
   F33(nm1)=1.d0
   
   ! Store identity matrices in V:
!   do i=1,(nm1)
      V12=0.d0
      V11=1.d0
      V22=1.d0
      V21=0.d0
!   enddo
   
   ! Initialize the vectors p and q:
   q=poly;
   q(n)=q(n)+1.d0
   p=0.d0
   p(1)=1.d0


   !******* BEGIN APPROX CYCLE ************************
   
   approx:do while (defl_size>2)
   iterate:do
  
  ! Initialize Q with identity matrices. 
 !  do i=1,(nm1)
 !    QQ11(i)=1.d0
 !    QQ22(i)=1.d0
 !    QQ33(i)=1.d0
 !    QQ12(i)=0.d0
 !    QQ13(i)=0.d0
 !    QQ21(i)=0.d0
 !    QQ23(i)=0.d0
 !    QQ31(i)=0.d0
 !    QQ32(i)=0.d0
 !  enddo
   
     QQ11=1.d0
     QQ22=1.d0
     QQ33=1.d0
     QQ12=0.d0
     QQ13=0.d0
     QQ21=0.d0
     QQ23=0.d0
     QQ31=0.d0
     QQ32=0.d0
 
   ! Use the previously computed V and F to update the
   ! quasiseparable representation (step 1 in Thm. 3.1).

   h1(1:nm2)=F11(1:nm2)
   h2(1:nm2)=F21(1:nm2)
   b11(1:nm2)=F12(1:nm2)
   b12(1:nm2)=F13(1:nm2)
   b21(1:nm2)=F22(1:nm2)
   b22(1:nm2)=F23(1:nm2)
   h1(nm1)=F11(nm1)
   h2(nm1)=F21(nm1)
   b11(nm1)=F12(nm1)
   b12(nm1)=0.d0
   b21(nm1)=F22(nm1)
   b22(nm1)=0.d0
   h1(n)=1.d0
   h2(n)=0.d0  
   gamma1(1)=0.d0
   gamma2(1)=1.d0
   g1(1)=1.d0
   g2(1)=0.d0
   do k=1,nm2
         kp1=k+1
         !auxMM(1,1)=gamma1(k)*F11(k)+gamma2(k)*F21(k)
         !auxMM(1,2)=gamma1(k)*F12(k)+gamma2(k)*F22(k)
         !auxMM(1,3)=gamma1(k)*F13(k)+gamma2(k)*F23(k)
         aux1=gamma1(k)*F11(k)+gamma2(k)*F21(k)
         aux2=gamma1(k)*F12(k)+gamma2(k)*F22(k)
         aux3=gamma1(k)*F13(k)+gamma2(k)*F23(k)
         !auxMM(2,1)=F31(k)
         !auxMM(2,2)=F32(k)
         !auxMM(2,3)=F33(k)
        ! MM(1,1)=V11(kp1)*auxMM(1,1)+V12(kp1)*F31(k)
        ! MM(1,2)=V11(kp1)*auxMM(1,2)+V12(kp1)*F32(k)
        ! MM(1,3)=V11(kp1)*auxMM(1,3)+V12(kp1)*F33(k)
        ! MM(2,1)=V21(kp1)*auxMM(1,1)+V22(kp1)*F31(k)
        ! MM(2,2)=V21(kp1)*auxMM(1,2)+V22(kp1)*F32(k)
        ! MM(2,3)=V21(kp1)*auxMM(1,3)+V22(kp1)*F33(k)
         sigma(k)=V11(kp1)*aux1+V12(kp1)*F31(k)
         !g(kp1,:)=MM(1,2:3)
         g1(kp1)=V11(kp1)*aux2+V12(kp1)*F32(k)
         g2(kp1)=V11(kp1)*aux3+V12(kp1)*F33(k)
         !gamma(kp1,:)=MM(2,2:3)
         gamma1(kp1)=V21(kp1)*aux2+V22(kp1)*F32(k)
         gamma2(kp1)=V21(kp1)*aux3+V22(kp1)*F33(k)
   enddo
   sigma(nm1)=(gamma1(nm1)*h1(nm1))+(gamma2(nm1)*h2(nm1))
   g1(n)=gamma1(nm1)*b11(nm1)+gamma2(nm1)*b21(nm1)
   g2(n)=gamma1(nm1)*b12(nm1)+gamma2(nm1)*b22(nm1)
      
   ! Compute beta (step 2 in Thm 3.1):
   beta(1:2)=0.d0
   beta(n)=p(n)
   do k=nm1,3,-1
         beta(k)=V11(k)*p(k)+V21(k)*beta(k+1)
   enddo
   oldp=p;
   ! Compute the vectors of diagonal and subdiagonal entries:
   do k=1,n
         diagonals(k)=g1(k)*h1(k)+g2(k)*h2(k)-p(k)*q(k)
   enddo
   do k=1,nm1
         subdiag(k)=sigma(k)-p(k+1)*q(k)
   enddo
   ! Compute a_final (2x2 trailing matrix)
     a_final(1,1)=diagonals(defl_size)
     auxvec(1)=b11(defl_size)*h1(defl_size+1)+b12(defl_size)*h2(defl_size+1)
     auxvec(2)=b21(defl_size)*h1(defl_size+1)+b22(defl_size)*h2(defl_size+1)
     a_final(1,2)=g1(defl_size)*auxvec(1)+g2(defl_size)*auxvec(2)-p(defl_size)*q(defl_size+1)
     a_final(2,1)=subdiag(defl_size)
     a_final(2,2)=diagonals(defl_size+1)

   ! Look for single small subdiagonal element
   smallsinglesub:do k=defl_size,1,-1
                  if (abs(subdiag(k))<threshold)then
!if (abs(subdiag(k))<threshold*(abs(diagonals(k)+abs(diagonals(k+1)))))then
                    exit smallsinglesub
                  endif 
                  enddo smallsinglesub
   m=k               
   ! Have we found any eigenvalues?
   oneeig:if (m==defl_size)then    ! one real eigenvalue found
     myeigre(defl_size+1)=diagonals(defl_size+1)
     myeigim(defl_size+1)=0.d0
   !  write(*,*)"Single deflation...",defl_size  
     defl_size=defl_size-1
     exit iterate  ! go back for next eigenvalue
   endif oneeig
   twoeig:if (m==defl_size-1) then ! two eigenvalues found      
     s=abs(a_final(1,1))+abs(a_final(2,1))+abs(a_final(1,2))+abs(a_final(2,2))
     na_final=a_final/s  ! normalize a_final
     tr=(na_final(1,1)+na_final(2,2))/(2.d0)
     det=(na_final(1,1)-tr)*(na_final(2,2)-tr)-na_final(1,2)*na_final(2,1)
!    write(*,*)"det= ",det
      myeigre(defl_size+1)=tr*s;
     myeigre(defl_size)=myeigre(defl_size+1)
     rtdisc=sqrt(abs(det))
     if (det>0.d0)then    ! complex conjugate eigenvalues
       myeigim(defl_size)=rtdisc*s
       myeigim(defl_size+1)=-myeigim(defl_size)
     else
       write(*,*)"Pair of real roots" 
     myeigre(defl_size+1)=myeigre(defl_size+1)+rtdisc*s
     myeigre(defl_size)=myeigre(defl_size)-rtdisc*s 
     myeigim(defl_size)=0.d0
     myeigim(defl_size+1)=0.d0
     endif
!af11=a_final(1,1)
!af12=a_final(1,2)
!af21=a_final(2,1)
!af22=a_final(2,2)
!call dlanv2(af11,af12,af21,af22,myeigre(defl_size),myeigim(defl_size),myeigre(defl_size+1),myeigim(defl_size+1),cs,cn)
!     write(*,*)"Double deflation...",defl_size
     defl_size=defl_size-2 
     exit iterate   ! go back for next eigenvalue
   endif twoeig
  
   !No roots found, continue iteration 
    iterations(defl_size+1)=iterations(defl_size+1)+1
 !write(*,"(a)",advance="no") "."
   if (iterations(defl_size+1)==50)then
     write(*,*)"I give up."
     exit approx
   endif
   if (iterations(defl_size+1)==30)then
     write(*,*)"30 iterations!",defl_size
     random_flag=1
    ! call random_number(random_sum)
    ! call random_number(random_prod)
random_sum=1.5d0*(abs(subdiag(defl_size-1))+abs(subdiag(defl_size)))
random_prod=(abs(subdiag(defl_size-1))+abs(subdiag(defl_size)))**2
   endif
   if (iterations(defl_size+1)==15)then
     write(*,*)"Two consecutive random shifts!"
     random_flag=1
    ! call random_number(random_sum)
    ! call random_number(random_prod)
random_sum=1.5d0*(abs(subdiag(defl_size-1))+abs(subdiag(defl_size)))
random_prod=(abs(subdiag(defl_size-1))+abs(subdiag(defl_size)))**2
write(*,*)subdiag(defl_size-1)
write(*,*)subdiag(defl_size)
write(*,*)diagonals(defl_size+1)
write(*,*)diagonals(defl_size)
   endif
   if (iterations(defl_size+1)==8)then
     write(*,*)"Random shift..."
     random_flag=1
     !call random_number(random_sum)
     !call random_number(random_prod)
random_sum=1.5d0*(abs(subdiag(defl_size-1))+abs(subdiag(defl_size)))
random_prod=(abs(subdiag(defl_size-1))+abs(subdiag(defl_size)))**2
   endif 
   ! Look for a place where the "magic trick" might happen
   k=defl_size-1; ! now assume that the bulge-chasing process starts from k...
   m=m+1
   magic: do while (k>m)
   kp1=k+1
   ! compute the first "special vector"
   a_initial(1,1)=diagonals(k)
   x(1)=b11(k)*h1(kp1)+b12(k)*h2(kp1)
   x(2)=b21(k)*h1(kp1)+b22(k)*h2(kp1)
   ys=g1(k)*x(1)+g2(k)*x(2)
   a_initial(1,2)=ys-p(k)*q(kp1)
   a_initial(2,1)=subdiag(k)
   a_initial(2,2)=diagonals(kp1)
   if (random_flag==0)then
     nrm(1)=((a_final(2,2)-a_initial(1,1))*(a_final(1,1)-a_initial(1,1))-a_final(1,2)*a_final(2,1))/a_initial(2,1)+a_initial(1,2)
     nrm(2)=a_initial(2,2)-a_initial(1,1)-(a_final(2,2)-a_initial(1,1))-(a_final(1,1)-a_initial(1,1))
     nrm(3)=subdiag(kp1)
   else
     nrm(1)=a_initial(1,1)*a_initial(1,1)-a_initial(1,1)*random_sum+random_prod+a_initial(1,2)*a_initial(2,1)
     nrm(2)=a_initial(2,1)*(a_initial(1,1)+a_initial(2,2)-random_sum)
     nrm(3)=a_initial(2,1)*subdiag(kp1)
   endif            
   ! normalize nrm as suggested in NR
   nrs=abs(nrm(1))+abs(nrm(2))+abs(nrm(3))
   nrm=nrm/nrs;
  
!call householder(GG,nrm)
!if (abs(subdiag(k-1))*(abs(GG(2,1))+abs(GG(3,1)))<2*threshold)then
 nrc=epsilon(1.d0)*abs(nrm(1))*(abs(diagonals(k+1))+abs(diagonals(k))+abs(diagonals(k-1)))
        if (abs(subdiag(k-1))*(abs(nrm(2))+abs(nrm(3)))<nrc)then
     exit magic
end if
   
   k=k-1
   enddo magic
   m=k 



! ****** BULGE CHASING ***********************************
         !
         ! (step 3 in Thm. 3.1)
         !
         ! Perform the bulge chasing process on the submatrix
         ! (m:defl_size+1, m:defl_size+1).
         newq=0.d0
         newp=0.d0
         ptau=0.d0
         qtau=0.d0
         
         !do j=1,n
         !  gtau1(j)=0.d0
         !  gtau2(j)=0.d0
         !enddo

         gtau1=0.d0
         gtau2=0.d0
 qtau(m)=q(m);
 ! Compute and apply (on the left) the first Givens rotation:
 a_initial(1,1)=diagonals(m)
 x(1)=b11(m)*h1(m+1)+b12(m)*h2(m+1)
 x(2)=b21(m)*h1(m+1)+b22(m)*h2(m+1)
 ys=g1(m)*x(1)+g2(m)*x(2)
 a_initial(1,2)=ys-p(m)*q(m+1)
 a_initial(2,1)=subdiag(m)
 a_initial(2,2)=diagonals(m+1)
 if (random_flag==0)then
  nrm(1)=((a_final(2,2)-a_initial(1,1))*(a_final(1,1)-a_initial(1,1))-a_final(1,2)*a_final(2,1))/a_initial(2,1)+a_initial(1,2)
             nrm(2)=a_initial(2,2)-a_initial(1,1)-(a_final(2,2)-a_initial(1,1))-(a_final(1,1)-a_initial(1,1))
             nrm(3)=subdiag(m+1)
             ! normalize nrm as suggested in NR
             nrs=abs(nrm(1))+abs(nrm(2))+abs(nrm(3))
             nrm=nrm/nrs
             else
               random_flag=0
   end if
      call householder(GG,nrm)
      QQ11(m)=GG(1,1)
      QQ12(m)=GG(2,1)
      QQ13(m)=GG(3,1)
      QQ21(m)=GG(1,2)
      QQ22(m)=GG(2,2)
      QQ23(m)=GG(3,2)
      QQ31(m)=GG(1,3)
      QQ32(m)=GG(2,3)
      QQ33(m)=GG(3,3)
      
 Xa(1,1)=g1(m)*h1(m)+g2(m)*h2(m)
 x(1)=b11(m)*h1(m+1)+b12(m)*h2(m+1)
 x(2)=b21(m)*h1(m+1)+b22(m)*h2(m+1)
 ys=g1(m)*x(1)+g2(m)*x(2)
 Xa(1,2)=ys
 bb(1,1)=b11(m)*b11(m+1)+b12(m)*b21(m+1)
 bb(1,2)=b11(m)*b12(m+1)+b12(m)*b22(m+1)
 bb(2,1)=b21(m)*b11(m+1)+b22(m)*b21(m+1)
 bb(2,2)=b21(m)*b12(m+1)+b22(m)*b22(m+1)
 Xa(1,3)=g1(m)*bb(1,1)+g2(m)*bb(2,1)
 Xa(1,4)=g1(m)*bb(1,2)+g2(m)*bb(2,2) 
 Xa(2,1)=sigma(m)
 Xa(2,2)=g1(m+1)*h1(m+1)+g2(m+1)*h2(m+1)
 Xa(2,3)=g1(m+1)*b11(m+1)+g2(m+1)*b21(m+1)
 Xa(2,4)=g1(m+1)*b12(m+1)+g2(m+1)*b22(m+1) 
 Xa(3,1)=p(m+2)*q(m)
 Xa(3,2)=sigma(m+1)
 !Xa(3,3:4)=g(m+2,:)
 Xa(3,3)=g1(m+2)
 Xa(3,4)=g2(m+2)
 
 !Xb=matmul(GG,Xa)
Xb(1,1)=GG(1,1)*Xa(1,1)+GG(1,2)*Xa(2,1)+GG(1,3)*Xa(3,1)
 Xb(1,2)=GG(1,1)*Xa(1,2)+GG(1,2)*Xa(2,2)+GG(1,3)*Xa(3,2)
 Xb(1,3)=GG(1,1)*Xa(1,3)+GG(1,2)*Xa(2,3)+GG(1,3)*Xa(3,3)
 Xb(1,4)=GG(1,1)*Xa(1,4)+GG(1,2)*Xa(2,4)+GG(1,3)*Xa(3,4)
 Xb(2,1)=GG(2,1)*Xa(1,1)+GG(2,2)*Xa(2,1)+GG(2,3)*Xa(3,1)
 Xb(2,2)=GG(2,1)*Xa(1,2)+GG(2,2)*Xa(2,2)+GG(2,3)*Xa(3,2)
 Xb(2,3)=GG(2,1)*Xa(1,3)+GG(2,2)*Xa(2,3)+GG(2,3)*Xa(3,3)
 Xb(2,4)=GG(2,1)*Xa(1,4)+GG(2,2)*Xa(2,4)+GG(2,3)*Xa(3,4)
 Xb(3,1)=GG(3,1)*Xa(1,1)+GG(3,2)*Xa(2,1)+GG(3,3)*Xa(3,1)
 Xb(3,2)=GG(3,1)*Xa(1,2)+GG(3,2)*Xa(2,2)+GG(3,3)*Xa(3,2)
 Xb(3,3)=GG(3,1)*Xa(1,3)+GG(3,2)*Xa(2,3)+GG(3,3)*Xa(3,3)
 Xb(3,4)=GG(3,1)*Xa(1,4)+GG(3,2)*Xa(2,4)+GG(3,3)*Xa(3,4)
 !gtau(m+2,:)=Xb(3,3:4)
 gtau1(m+2)=Xb(3,3)
 gtau2(m+2)=Xb(3,4)
 vec3=p(m:m+2)
 !p(m:m+2)=matmul(GG,p(m:m+2))
 p(m)=QQ11(m)*vec3(1)+QQ21(m)*vec3(2)+QQ31(m)*vec3(3)
p(m+1)=QQ12(m)*vec3(1)+QQ22(m)*vec3(2)+QQ32(m)*vec3(3)
p(m+2)=QQ13(m)*vec3(1)+QQ23(m)*vec3(2)+QQ33(m)*vec3(3)
 ! ************** begin bulge chasing cycle *************
!HH=0.d0
         k=m
         do while (k<defl_size-1)
kp1=k+1
kp2=k+2
 ! Multiply by the old G on the right:

 subHH(1,1)=Xb(2,1)-p(k+1)*q(k)
      subHH(1,2)=Xb(2,2)-p(k+1)*q(k+1)
      subHH(1,3)=Xb(2,3)*h1(kp2)+Xb(2,4)*h2(kp2)-p(k+1)*q(kp2)
      subHH(2,1)=Xb(3,1)-p(kp2)*q(k)
      subHH(2,2)=Xb(3,2)-p(kp2)*q(kp1)
      subHH(2,3)=gtau1(kp2)*h1(kp2)+gtau2(kp2)*h2(kp2)-p(kp2)*q(kp2)
      !subHH(3,1)=0.d0
      !subHH(3,2)=0.d0
      subHH(3,3)=sigma(kp2)-p(k+3)*q(kp2)
! HH(:,1)=subHH(:,1)*QQ11(k)+subHH(:,2)*QQ21(k)+subHH(:,3)*QQ31(k)
HH(1,1)=subHH(1,1)*QQ11(k)+subHH(1,2)*QQ21(k)+subHH(1,3)*QQ31(k)
HH(2,1)=subHH(2,1)*QQ11(k)+subHH(2,2)*QQ21(k)+subHH(2,3)*QQ31(k)
HH(3,1)=subHH(3,3)*QQ31(k)
! HH(:,2)=subHH(:,1)*QQ12(k)+subHH(:,2)*QQ22(k)+subHH(:,3)*QQ32(k)
HH(1,2)=subHH(1,1)*QQ12(k)+subHH(1,2)*QQ22(k)+subHH(1,3)*QQ32(k)
HH(2,2)=subHH(2,1)*QQ12(k)+subHH(2,2)*QQ22(k)+subHH(2,3)*QQ32(k)
HH(3,2)=subHH(3,3)*QQ32(k)
! HH(:,3)=subHH(:,1)*QQ13(k)+subHH(:,2)*QQ23(k)+subHH(:,3)*QQ33(k)

 !Ya(1,1)=Xb(2,1)
 !Ya(1,2)=Xb(2,2)
 Ya13=Xb(2,3)*h1(kp2)+Xb(2,4)*h2(kp2)
 !Ya(2,1)=Xb(3,1)
 !Ya(2,2)=Xb(3,2)
 Ya23=gtau1(kp2)*h1(kp2)+gtau2(kp2)*h2(kp2)
 Ya31=p(k+3)*q(k)
 Ya32=p(k+3)*q(kp1)
 !Ya(3,3)=sigma(kp2)
 !Yb(:,1)=Ya(:,1)*QQ11(k)+Ya(:,2)*QQ21(k)+Ya(:,3)*QQ31(k)
!Yb(1,1)=Ya(1,1)*QQ11(k)+Ya(1,2)*QQ21(k)+Ya(1,3)*QQ31(k)
!Yb(2,1)=Ya(2,1)*QQ11(k)+Ya(2,2)*QQ21(k)+Ya(2,3)*QQ31(k)
!Yb(3,1)=Ya(3,1)*QQ11(k)+Ya(3,2)*QQ21(k)+Ya(3,3)*QQ31(k)
! Yb(:,2)=Ya(:,1)*QQ12(k)+Ya(:,2)*QQ22(k)+Ya(:,3)*QQ32(k)
Yb(1,2)=Xb(2,1)*QQ12(k)+Xb(2,2)*QQ22(k)+Ya13*QQ32(k)
Yb(2,2)=Xb(3,1)*QQ12(k)+Xb(3,2)*QQ22(k)+Ya23*QQ32(k)
Yb(3,2)=Ya31*QQ12(k)+Ya32*QQ22(k)+sigma(kp2)*QQ32(k)
! Yb(:,3)=Ya(:,1)*QQ13(k)+Ya(:,2)*QQ23(k)+Ya(:,3)*QQ33(k)
 Yb(1,3)=Xb(2,1)*QQ13(k)+Xb(2,2)*QQ23(k)+Ya13*QQ33(k)
 Yb(2,3)=Xb(3,1)*QQ13(k)+Xb(3,2)*QQ23(k)+Ya23*QQ33(k)
 Yb(3,3)=Ya31*QQ13(k)+Ya32*QQ23(k)+sigma(kp2)*QQ33(k)

 vec3=q(k:kp2)
 q(k)=QQ11(k)*vec3(1)+QQ21(k)*vec3(2)+QQ31(k)*vec3(3)
 q(kp1)=QQ12(k)*vec3(1)+QQ22(k)*vec3(2)+QQ32(k)*vec3(3)
 q(kp2)=QQ13(k)*vec3(1)+QQ23(k)*vec3(2)+QQ33(k)*vec3(3)
 
 call hhbulge(GG,HH)
 QQ11(kp1)=GG(1,1)
 QQ12(kp1)=GG(2,1)
 QQ13(kp1)=GG(3,1)
 QQ21(kp1)=GG(1,2)
 QQ22(kp1)=GG(2,2)
 QQ23(kp1)=GG(3,2)
 QQ31(kp1)=GG(1,3)
 QQ32(kp1)=GG(2,3)
 QQ33(kp1)=GG(3,3)
 
 ! Multiply on the left by the new G:
             vec3=p(kp1:k+3)
p(kp1)=QQ11(kp1)*vec3(1)+QQ21(kp1)*vec3(2)+QQ31(kp1)*vec3(3)
p(kp2)=QQ12(kp1)*vec3(1)+QQ22(kp1)*vec3(2)+QQ32(kp1)*vec3(3)
p(k+3)=QQ13(kp1)*vec3(1)+QQ23(kp1)*vec3(2)+QQ33(kp1)*vec3(3)

 !Xa(:,1:2)=Yb(:,2:3)
 Xa(1,3)=Xb(2,3)*b11(kp2)+Xb(2,4)*b21(kp2)
 Xa(1,4)=Xb(2,3)*b12(kp2)+Xb(2,4)*b22(kp2)
 Xa(2,3)=gtau1(kp2)*b11(kp2)+gtau2(kp2)*b21(kp2) 
 Xa(2,4)=gtau1(kp2)*b12(kp2)+gtau2(kp2)*b22(kp2)
 !Xa(3,3:4)=g(k+3,:)
 !Xa(3,3)=g1(k+3)
 !Xa(3,4)=g2(k+3)
 
 !Xb=matmul(aux33,Xa)
 !Xb=matmul(GG,Xa)
Xb(2,1)=GG(2,1)*Yb(1,2)+GG(2,2)*Yb(2,2)+GG(2,3)*Yb(3,2)
 Xb(2,2)=GG(2,1)*Yb(1,3)+GG(2,2)*Yb(2,3)+GG(2,3)*Yb(3,3)
 Xb(2,3)=GG(2,1)*Xa(1,3)+GG(2,2)*Xa(2,3)+GG(2,3)*g1(k+3)
 Xb(2,4)=GG(2,1)*Xa(1,4)+GG(2,2)*Xa(2,4)+GG(2,3)*g2(k+3)
 Xb(3,1)=GG(3,1)*Yb(1,2)+GG(3,2)*Yb(2,2)+GG(3,3)*Yb(3,2)
 Xb(3,2)=GG(3,1)*Yb(1,3)+GG(3,2)*Yb(2,3)+GG(3,3)*Yb(3,3)
 Xb(3,3)=GG(3,1)*Xa(1,3)+GG(3,2)*Xa(2,3)+GG(3,3)*g1(k+3)
 Xb(3,4)=GG(3,1)*Xa(1,4)+GG(3,2)*Xa(2,4)+GG(3,3)*g2(k+3)
 !gtau(k+3,:)=Xb(3,3:4) 
 gtau1(k+3)=Xb(3,3)
 gtau2(k+3)=Xb(3,4) 
! Increase counter:
 k=kp1
 enddo
 
Za(1,1)=Xb(2,1)
Za(1,2)=Xb(2,2)
Za(1,3)=Xb(2,3)*h1(k+2)+Xb(2,4)*h2(k+2)
Za(2,1)=Xb(3,1)
Za(2,2)=Xb(3,2)
Za(2,3)=gtau1(k+2)*h1(k+2)+gtau2(k+2)*h2(k+2)
Zb(:,1)=Za(:,1)*QQ11(k)+Za(:,2)*QQ21(k)+Za(:,3)*QQ31(k)
!Zb(:,2)=Za(:,1)*QQ12(k)+Za(:,2)*QQ22(k)+Za(:,3)*QQ32(k)
!Zb(:,3)=Za(:,1)*QQ13(k)+Za(:,2)*QQ23(k)+Za(:,3)*QQ33(k)
vec3=q(k:k+2)
q(k)=QQ11(k)*vec3(1)+QQ21(k)*vec3(2)+QQ31(k)*vec3(3)
q(k+1)=QQ12(k)*vec3(1)+QQ22(k)*vec3(2)+QQ32(k)*vec3(3)
q(k+2)=QQ13(k)*vec3(1)+QQ23(k)*vec3(2)+QQ33(k)*vec3(3)


lastbulge(1,1)=Zb(1,1)-p(defl_size)*q(defl_size-1)
!lastbulge(1,2)=Zb(1,2)-p(defl_size)*q(defl_size)
!lastbulge(1,3)=Zb(1,3)-p(defl_size)*q(defl_size+1)
lastbulge(2,1)=Zb(2,1)-p(defl_size+1)*q(defl_size-1)
!lastbulge(2,2)=Zb(2,2)-p(defl_size+1)*q(defl_size)
!lastbulge(2,3)=Zb(2,3)-p(defl_size+1)*q(defl_size+1)
 
call slimgivens(lastbulge(:,1),w1,w2)
!lastsmallQ=transpose(Gv)
lastsmallQ(1,1)=w1
lastsmallQ(1,2)=-w2
lastsmallQ(2,1)=w2
lastsmallQ(2,2)=w1
newq=q
newp=p 
!newp(defl_size:defl_size+1)=matmul(Gv,p(defl_size:defl_size+1))
newp(defl_size)=w1*p(defl_size)+w2*p(defl_size+1)
newp(defl_size+1)=-w2*p(defl_size)+w1*p(defl_size+1)
!newq(defl_size:defl_size+1)=matmul(Gv,q(defl_size:defl_size+1))
newq(defl_size)=w1*q(defl_size)+w2*q(defl_size+1)
newq(defl_size+1)=-w2*q(defl_size)+w1*q(defl_size+1)
newp(1:m-1)=p(1:m-1)
newq(1:m-1)=q(1:m-1)

!call givens(lastbulge(:,1),Gv)
!lastsmallQ=transpose(Gv)
!newq=q
!newp=p 
!newp(defl_size:defl_size+1)=matmul(Gv,p(defl_size:defl_size+1))
!newq(defl_size:defl_size+1)=matmul(Gv,q(defl_size:defl_size+1))
!newp(1:m-1)=p(1:m-1);
!newq(1:m-1)=q(1:m-1);

 ! **************** end bulge chasing cycle ***************

        ! Update V and F (step 4 in Thm. 3.1).

ptau(1:m)=p(1:m)

if(defl_size>n-8)then   ! ATTENZIONE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

if (m==1)then

            ! *********
            ! First step:
            !**********

            auxp=oldp(1:5)
            auxp(5)=beta(5)
            vec3=auxp(1:3)
            auxp(1)=QQ11(1)*vec3(1)+QQ21(1)*vec3(2)+QQ31(1)*vec3(3)
auxp(2)=QQ12(1)*vec3(1)+QQ22(1)*vec3(2)+QQ32(1)*vec3(3)
auxp(3)=QQ13(1)*vec3(1)+QQ23(1)*vec3(2)+QQ33(1)*vec3(3)
            
            vec3=auxp(2:4)
auxp(2)=QQ11(2)*vec3(1)+QQ21(2)*vec3(2)+QQ31(2)*vec3(3)
auxp(3)=QQ12(2)*vec3(1)+QQ22(2)*vec3(2)+QQ32(2)*vec3(3)
auxp(4)=QQ13(2)*vec3(1)+QQ23(2)*vec3(2)+QQ33(2)*vec3(3)
          
            auxF=0.d0
            auxF(4,4)=1.d0
            auxF(5,5)=1.d0

auxF(1,1)=QQ11(1)
auxF(1,2)=QQ12(1)
auxF(1,3)=QQ13(1)
auxF(2,1)=QQ21(1)
auxF(2,2)=QQ22(1)
auxF(2,3)=QQ23(1)
auxF(3,1)=QQ31(1)
auxF(3,2)=QQ32(1)
auxF(3,3)=QQ33(1)
subauxF=auxF(3:5,:)
            auxF(3,:)=F11(3)*subauxF(1,:)+F12(3)*subauxF(2,:)+F13(3)*subauxF(3,:)
             auxF(4,:)=F21(3)*subauxF(1,:)+F22(3)*subauxF(2,:)+F23(3)*subauxF(3,:)
             auxF(5,:)=F31(3)*subauxF(1,:)+F32(3)*subauxF(2,:)+F33(3)*subauxF(3,:)
             subauxF=auxF(2:4,:)
              auxF(2,:)=F11(2)*subauxF(1,:)+F12(2)*subauxF(2,:)+F13(2)*subauxF(3,:)
             auxF(3,:)=F21(2)*subauxF(1,:)+F22(2)*subauxF(2,:)+F23(2)*subauxF(3,:)
             auxF(4,:)=F31(2)*subauxF(1,:)+F32(2)*subauxF(2,:)+F33(2)*subauxF(3,:)
             subauxF=auxF(1:3,:)
               auxF(1,:)=F11(1)*subauxF(1,:)+F12(1)*subauxF(2,:)+F13(1)*subauxF(3,:)
             auxF(2,:)=F21(1)*subauxF(1,:)+F22(1)*subauxF(2,:)+F23(1)*subauxF(3,:)
             auxF(3,:)=F31(1)*subauxF(1,:)+F32(1)*subauxF(2,:)+F33(1)*subauxF(3,:)
             subsubauxF=auxF(2:3,:)
              auxF(2,:)=V11(2)*subsubauxF(1,:)+V12(2)*subsubauxF(2,:)
             auxF(3,:)=V21(2)*subsubauxF(1,:)+V22(2)*subsubauxF(2,:)
            subsubauxF=auxF(3:4,:)
               auxF(3,:)=V11(3)*subsubauxF(1,:)+V12(3)*subsubauxF(2,:)
             auxF(4,:)=V21(3)*subsubauxF(1,:)+V22(3)*subsubauxF(2,:)
            subsubauxF=auxF(4:5,:)
            auxF(4,:)=V11(4)*subsubauxF(1,:)+V12(4)*subsubauxF(2,:)
             auxF(5,:)=V21(4)*subsubauxF(1,:)+V22(4)*subsubauxF(2,:)
            subauxF=auxF(1:3,:)
            aux33(1,1)=QQ11(1)
aux33(1,2)=QQ21(1)
aux33(1,3)=QQ31(1)
aux33(2,1)=QQ12(1)
aux33(2,2)=QQ22(1)
aux33(2,3)=QQ32(1)
aux33(3,1)=QQ13(1)
aux33(3,2)=QQ23(1)
aux33(3,3)=QQ33(1)
         !   auxF(1:3,:)=matmul(aux33,subauxF)
auxF(1,:)=aux33(1,1)*subauxF(1,:)+aux33(1,2)*subauxF(2,:)+aux33(1,3)*subauxF(3,:)
auxF(2,:)=aux33(2,1)*subauxF(1,:)+aux33(2,2)*subauxF(2,:)+aux33(2,3)*subauxF(3,:)
auxF(3,:)=aux33(3,1)*subauxF(1,:)+aux33(3,2)*subauxF(2,:)+aux33(3,3)*subauxF(3,:)
            subauxF=auxF(2:4,:)
            aux33(1,1)=QQ11(2)
aux33(1,2)=QQ21(2)
aux33(1,3)=QQ31(2)
aux33(2,1)=QQ12(2)
aux33(2,2)=QQ22(2)
aux33(2,3)=QQ32(2)
aux33(3,1)=QQ13(2)
aux33(3,2)=QQ23(2)
aux33(3,3)=QQ33(2)
           ! auxF(2:4,:)=matmul(aux33,subauxF)
auxF(2,:)=aux33(1,1)*subauxF(1,:)+aux33(1,2)*subauxF(2,:)+aux33(1,3)*subauxF(3,:)
auxF(3,:)=aux33(2,1)*subauxF(1,:)+aux33(2,2)*subauxF(2,:)+aux33(2,3)*subauxF(3,:)
auxF(4,:)=aux33(3,1)*subauxF(1,:)+aux33(3,2)*subauxF(2,:)+aux33(3,3)*subauxF(3,:)


bulgenorm=abs(auxF(5,1))+abs(auxF(5,2))+abs(auxF(4,1))
auxpnorm=abs(auxp(3))+abs(auxp(4))+abs(auxp(5))
           if (bulgenorm>auxpnorm)then
             
            call givens(auxF(4:5,1),Gv)
             Vtau11(4)=Gv(1,1)
             Vtau12(4)=Gv(2,1)
             Vtau21(4)=Gv(1,2)
             Vtau22(4)=Gv(2,2)

            subsubauxF=auxF(4:5,:)
               aux22(1,1)=Vtau11(4)
             aux22(1,2)=Vtau21(4)
             aux22(2,1)=Vtau12(4)
             aux22(2,2)=Vtau22(4)
            ! auxF(4:5,:)=matmul(aux22,subsubauxF)
auxF(4,:)=aux22(1,1)*subsubauxF(1,:)+aux22(1,2)*subsubauxF(2,:)
auxF(5,:)=aux22(2,1)*subsubauxF(1,:)+aux22(2,2)*subsubauxF(2,:)

            call givens(auxF(3:4,1),Gv)
               Vtau11(3)=Gv(1,1)
             Vtau12(3)=Gv(2,1)
             Vtau21(3)=Gv(1,2)
             Vtau22(3)=Gv(2,2)
vec2=auxp(4:5)
aux22(1,1)=Vtau11(4)
             aux22(1,2)=Vtau21(4)
             aux22(2,1)=Vtau12(4)
             aux22(2,2)=Vtau22(4)
!auxp(4:5)=matmul(aux22,vec2)
auxp(4)=aux22(1,1)*vec2(1)+aux22(1,2)*vec2(2)
auxp(5)=aux22(2,1)*vec2(1)+aux22(2,2)*vec2(2)
vec2=auxp(3:4)
aux22(1,1)=Vtau11(3)
             aux22(1,2)=Vtau21(3)
             aux22(2,1)=Vtau12(3)
             aux22(2,2)=Vtau22(3)
!            auxp(3:4)=matmul(aux22,vec2)
auxp(3)=aux22(1,1)*vec2(1)+aux22(1,2)*vec2(2)
auxp(4)=aux22(2,1)*vec2(1)+aux22(2,2)*vec2(2)
            call givens(auxp(2:3),Gv)
             Vtau11(2)=Gv(1,1)
             Vtau12(2)=Gv(2,1)
             Vtau21(2)=Gv(1,2)
             Vtau22(2)=Gv(2,2)
              newV11(2)=Gv(1,1)
             newV12(2)=Gv(2,1)
             newV21(2)=Gv(1,2)
             newV22(2)=Gv(2,2)
            
subsubauxF=auxF(3:4,:)
aux22(1,1)=Vtau11(3)
             aux22(1,2)=Vtau21(3)
             aux22(2,1)=Vtau12(3)
             aux22(2,2)=Vtau22(3)
! auxF(3:4,:)=matmul(aux22,subsubauxF)
auxF(3,:)=aux22(1,1)*subsubauxF(1,:)+aux22(1,2)*subsubauxF(2,:)
auxF(4,:)=aux22(2,1)*subsubauxF(1,:)+aux22(2,2)*subsubauxF(2,:)
 subsubauxF=auxF(2:3,:)
 aux22(1,1)=Vtau11(2)
             aux22(1,2)=Vtau21(2)
             aux22(2,1)=Vtau12(2)
             aux22(2,2)=Vtau22(2)
!            auxF(2:3,:)=matmul(aux22,subsubauxF)
auxF(2,:)=aux22(1,1)*subsubauxF(1,:)+aux22(1,2)*subsubauxF(2,:)
auxF(3,:)=aux22(2,1)*subsubauxF(1,:)+aux22(2,2)*subsubauxF(2,:)
else
 ! this is the case e.g. when P=ones(n+1,1)
            call givens(auxp(4:5),Gv)
                Vtau11(4)=Gv(1,1)
             Vtau12(4)=Gv(2,1)
             Vtau21(4)=Gv(1,2)
             Vtau22(4)=Gv(2,2)
               vec2=auxp(4:5)
!               auxp(4:5)=matmul(Gv,vec2)
auxp(4)=Gv(1,1)*vec2(1)+Gv(1,2)*vec2(2)
auxp(5)=Gv(2,1)*vec2(1)+Gv(2,2)*vec2(2)
             call givens(auxp(3:4),Gv)
                   Vtau11(3)=Gv(1,1)
             Vtau12(3)=Gv(2,1)
             Vtau21(3)=Gv(1,2)
             Vtau22(3)=Gv(2,2)
               vec2=auxp(3:4)
!               auxp(3:4)=matmul(Gv,vec2)
auxp(3)=Gv(1,1)*vec2(1)+Gv(1,2)*vec2(2)
auxp(4)=Gv(2,1)*vec2(1)+Gv(2,2)*vec2(2)

             call givens(auxp(2:3),Gv)
                Vtau11(2)=Gv(1,1)
             Vtau12(2)=Gv(2,1)
             Vtau21(2)=Gv(1,2)
             Vtau22(2)=Gv(2,2)
             newV11(2)=Gv(1,1)
             newV12(2)=Gv(2,1)
             newV21(2)=Gv(1,2)
             newV22(2)=Gv(2,2)
           subsubauxF=auxF(4:5,:)
             aux22(1,1)=Vtau11(4)
             aux22(1,2)=Vtau21(4)
             aux22(2,1)=Vtau12(4)
             aux22(2,2)=Vtau22(4)
!           auxF(4:5,:)=matmul(aux22,subsubauxF)
auxF(4,:)=aux22(1,1)*subsubauxF(1,:)+aux22(1,2)*subsubauxF(2,:)
auxF(5,:)=aux22(2,1)*subsubauxF(1,:)+aux22(2,2)*subsubauxF(2,:)
           subsubauxF=auxF(3:4,:)
            aux22(1,1)=Vtau11(3)
             aux22(1,2)=Vtau21(3)
             aux22(2,1)=Vtau12(3)
             aux22(2,2)=Vtau22(3)
!           auxF(3:4,:)=matmul(aux22,subsubauxF)
auxF(3,:)=aux22(1,1)*subsubauxF(1,:)+aux22(1,2)*subsubauxF(2,:)
auxF(4,:)=aux22(2,1)*subsubauxF(1,:)+aux22(2,2)*subsubauxF(2,:)

           subsubauxF=auxF(2:3,:)
            aux22(1,1)=Vtau11(2)
             aux22(1,2)=Vtau21(2)
             aux22(2,1)=Vtau12(2)
             aux22(2,2)=Vtau22(2)
!           auxF(2:3,:)=matmul(aux22,subsubauxF)
auxF(2,:)=aux22(1,1)*subsubauxF(1,:)+aux22(1,2)*subsubauxF(2,:)
auxF(3,:)=aux22(2,1)*subsubauxF(1,:)+aux22(2,2)*subsubauxF(2,:)
 endif
             
         call split4_for_ds(auxthree,oauxthree,aux33,auxF)
           newF11(1)=auxthree(1,1)
          newF12(1)=auxthree(1,2)
          newF13(1)=auxthree(1,3)
          newF21(1)=auxthree(2,1)
          newF22(1)=auxthree(2,2)
          newF23(1)=auxthree(2,3)
          newF31(1)=auxthree(3,1)
          newF32(1)=auxthree(3,2)
          newF33(1)=auxthree(3,3)
          Ftau11(2)=oauxthree(1,1)
          Ftau12(2)=oauxthree(1,2)
          Ftau13(2)=oauxthree(1,3)
          Ftau21(2)=oauxthree(2,1)
          Ftau22(2)=oauxthree(2,2)
          Ftau23(2)=oauxthree(2,3)
          Ftau31(2)=oauxthree(3,1)
          Ftau32(2)=oauxthree(3,2)
          Ftau33(2)=oauxthree(3,3)
          Ftau11(3)=aux33(1,1)
          Ftau12(3)=aux33(1,2)
          Ftau13(3)=aux33(1,3)
          Ftau21(3)=aux33(2,1)
          Ftau22(3)=aux33(2,2)
          Ftau23(3)=aux33(2,3)
          Ftau31(3)=aux33(3,1)
          Ftau32(3)=aux33(3,2)
          Ftau33(3)=aux33(3,3)

            if (defl_size<nm1) then
                 QQ11(defl_size)=lastsmallQ(1,1)
                 QQ12(defl_size)=lastsmallQ(1,2)
                 QQ13(defl_size)=0.d0
                 QQ21(defl_size)=lastsmallQ(2,1)
                 QQ22(defl_size)=lastsmallQ(2,2)
                 QQ23(defl_size)=0.d0
                 QQ31(defl_size)=0.d0
                 QQ32(defl_size)=0.d0
                 QQ33(defl_size)=1.d0
            end if

        do k=2,n-4
kp1=k+1
kp2=k+2
         !auxQC(1,1)=Vtau11(kp1)
         !auxQC(1,2)=Vtau12(kp1)
         !auxQC(1,3)=0.d0
         !auxQC(1,4)=0.d0
         
         auxQC(2,1)=Vtau11(kp2)*Vtau21(kp1)
         auxQC(2,2)=Vtau11(kp2)*Vtau22(kp1)
         !auxQC(2,3)=Vtau12(kp2)
         !auxQC(2,4)=0.d0
         
         auxQC(3,1)=V11(k+3)*Vtau21(kp2)*Vtau21(kp1)
         auxQC(3,2)=V11(k+3)*Vtau21(kp2)*Vtau22(kp1)
         auxQC(3,3)=V11(k+3)*Vtau22(kp2)
         !auxQC(3,4)=V12(k+3)
         
         !auxQC(4,1)=V21(k+3)*Vtau21(kp2)*Vtau21(kp1)
         !auxQC(4,2)=V21(k+3)*Vtau21(kp2)*Vtau22(kp1)
         !auxQC(4,3)=V21(k+3)*Vtau22(kp2)
         !auxQC(4,4)=V22(k+3)
 
         Vhat(1,1)=QQ11(kp1)*Vtau11(kp1)+QQ21(kp1)*auxQC(2,1)+QQ31(kp1)*auxQC(3,1)
         Vhat(1,2)=QQ11(kp1)*Vtau12(kp1)+QQ21(kp1)*auxQC(2,2)+QQ31(kp1)*auxQC(3,2)
         Vhat(1,3)=QQ21(kp1)*Vtau12(kp2)+QQ31(kp1)*auxQC(3,3)
         Vhat(1,4)=QQ31(kp1)*V12(k+3)
         Vhat(2,1)=QQ12(kp1)*Vtau11(kp1)+QQ22(kp1)*auxQC(2,1)+QQ32(kp1)*auxQC(3,1)
         Vhat(2,2)=QQ12(kp1)*Vtau12(kp1)+QQ22(kp1)*auxQC(2,2)+QQ32(kp1)*auxQC(3,2)
         Vhat(2,3)=QQ22(kp1)*Vtau12(kp2)+QQ32(kp1)*auxQC(3,3)
         Vhat(2,4)=QQ32(kp1)*V12(k+3)
         Vhat(3,1)=QQ13(kp1)*Vtau11(kp1)+QQ23(kp1)*auxQC(2,1)+QQ33(kp1)*auxQC(3,1)
         Vhat(3,2)=QQ13(kp1)*Vtau12(kp1)+QQ23(kp1)*auxQC(2,2)+QQ33(kp1)*auxQC(3,2)
         Vhat(3,3)=QQ23(kp1)*Vtau12(kp2)+QQ33(kp1)*auxQC(3,3)
         Vhat(3,4)=QQ33(kp1)*V12(k+3)
         !Vhat(4,:)=auxQC(4,:)
         Vhat(4,1)=V21(k+3)*Vtau21(kp2)*Vtau21(kp1)
         Vhat(4,2)=V21(k+3)*Vtau21(kp2)*Vtau22(kp1)
         Vhat(4,3)=V21(k+3)*Vtau22(kp2)
         Vhat(4,4)=V22(k+3)
         
         
         auxOC=0.d0
         auxOC(1,1)=QQ11(k)
         auxOC(1,2)=QQ12(k)
         auxOC(1,3)=QQ13(k)
         auxOC(2,1)=QQ21(k)
         auxOC(2,2)=QQ22(k)
         auxOC(2,3)=QQ23(k)
         !auxOC(3,1)=QQ31(k)
         !auxOC(3,2)=QQ32(k)
         !auxOC(3,3)=QQ33(k)
         !auxOC(5,5)=1.d0
         !auxOC(4,4)=1.d0
         !subauxOC=auxOC(3:5,:)
         !auxOC(3,:)=F11(kp2)*subauxOC(1,:)+F12(kp2)*subauxOC(2,:)+F13(kp2)*subauxOC(3,:)
         !auxOC(4,:)=F21(kp2)*subauxOC(1,:)+F22(kp2)*subauxOC(2,:)+F23(kp2)*subauxOC(3,:)
         !auxOC(5,:)=F31(kp2)*subauxOC(1,:)+F32(kp2)*subauxOC(2,:)+F33(kp2)*subauxOC(3,:) 
          auxOC(3,1)=F11(kp2)*QQ31(k)
      auxOC(3,2)=F11(kp2)*QQ32(k)
      auxOC(3,3)=F11(kp2)*QQ33(k)
      auxOC(3,4)=F12(kp2)
      auxOC(3,5)=F13(kp2)
      auxOC(4,1)=F21(kp2)*QQ31(k)
      auxOC(4,2)=F21(kp2)*QQ32(k)
      auxOC(4,3)=F21(kp2)*QQ33(k)
      auxOC(4,4)=F22(kp2)
      auxOC(4,5)=F23(kp2)
      auxOC(5,1)=F31(kp2)*QQ31(k)
      auxOC(5,2)=F31(kp2)*QQ32(k)
      auxOC(5,3)=F31(kp2)*QQ33(k)
      auxOC(5,4)=F32(kp2)
      auxOC(5,5)=F33(kp2)
      
         subauxOC=auxOC(2:4,:)
         
         auxOC(2,:)=Ftau11(kp1)*subauxOC(1,:)+Ftau12(kp1)*subauxOC(2,:)+Ftau13(kp1)*subauxOC(3,:)
         auxOC(3,:)=Ftau21(kp1)*subauxOC(1,:)+Ftau22(kp1)*subauxOC(2,:)+Ftau23(kp1)*subauxOC(3,:)
         auxOC(4,:)=Ftau31(kp1)*subauxOC(1,:)+Ftau32(kp1)*subauxOC(2,:)+Ftau33(kp1)*subauxOC(3,:)  
         subauxOC=auxOC(1:3,:)
         
         auxOC(1,:)=Ftau11(k)*subauxOC(1,:)+Ftau12(k)*subauxOC(2,:)+Ftau13(k)*subauxOC(3,:)
         auxOC(2,:)=Ftau21(k)*subauxOC(1,:)+Ftau22(k)*subauxOC(2,:)+Ftau23(k)*subauxOC(3,:)
         auxOC(3,:)=Ftau31(k)*subauxOC(1,:)+Ftau32(k)*subauxOC(2,:)+Ftau33(k)*subauxOC(3,:)    
         Fhat=auxOC  
         
            !   bulgethree=Vhat(1:3,2:4)
            !   aux33=transpose(bulgethree)
aux33(1,1)=Vhat(1,2)
aux33(1,2)=Vhat(2,2)
aux33(1,3)=Vhat(3,2)
aux33(2,1)=Vhat(1,3)
aux33(2,2)=Vhat(2,3)
aux33(2,3)=Vhat(3,3)
aux33(3,1)=Vhat(1,4)
aux33(3,2)=Vhat(2,4)
aux33(3,3)=Vhat(3,4)

               call hhbulge3(HH,aux33,Fhat(3:5,1:3),threshold)
              
        
         W(:,1)=Vhat(:,1)
         W(1,2)=Vhat(1,2)*HH(1,1)+Vhat(1,3)*HH(1,2)+Vhat(1,4)*HH(1,3)
         W(1,3)=Vhat(1,2)*HH(2,1)+Vhat(1,3)*HH(2,2)+Vhat(1,4)*HH(2,3)
         W(1,4)=Vhat(1,2)*HH(3,1)+Vhat(1,3)*HH(3,2)+Vhat(1,4)*HH(3,3)
         W(2,2)=Vhat(2,2)*HH(1,1)+Vhat(2,3)*HH(1,2)+Vhat(2,4)*HH(1,3)
         W(2,3)=Vhat(2,2)*HH(2,1)+Vhat(2,3)*HH(2,2)+Vhat(2,4)*HH(2,3)
         W(2,4)=Vhat(2,2)*HH(3,1)+Vhat(2,3)*HH(3,2)+Vhat(2,4)*HH(3,3)
         W(3,2)=Vhat(3,2)*HH(1,1)+Vhat(3,3)*HH(1,2)+Vhat(3,4)*HH(1,3)
         W(3,3)=Vhat(3,2)*HH(2,1)+Vhat(3,3)*HH(2,2)+Vhat(3,4)*HH(2,3)
         W(3,4)=Vhat(3,2)*HH(3,1)+Vhat(3,3)*HH(3,2)+Vhat(3,4)*HH(3,3)
         W(4,2)=Vhat(4,2)*HH(1,1)+Vhat(4,3)*HH(1,2)+Vhat(4,4)*HH(1,3)
         W(4,3)=Vhat(4,2)*HH(2,1)+Vhat(4,3)*HH(2,2)+Vhat(4,4)*HH(2,3)
         W(4,4)=Vhat(4,2)*HH(3,1)+Vhat(4,3)*HH(3,2)+Vhat(4,4)*HH(3,3)
               
         !D=0.d0
         !D(1,1)=1.d0
         !D(2,2)=1.d0
         !D(3:5,3:5)=HH
         !subD=D
         !D=matmul(subD,Fhat)
         D(1:2,:)=Fhat(1:2,:)
         D(3,:)=HH(1,1)*Fhat(3,:)+HH(1,2)*Fhat(4,:)+HH(1,3)*Fhat(5,:)
         D(4,:)=HH(2,1)*Fhat(3,:)+HH(2,2)*Fhat(4,:)+HH(2,3)*Fhat(5,:)
         D(5,:)=HH(3,1)*Fhat(3,:)+HH(3,2)*Fhat(4,:)+HH(3,3)*Fhat(5,:)
         
         call split3_for_ds(auxtwo,oauxtwo,aux22,W)
         Vtau11(k+3)=auxtwo(1,1)
            Vtau12(k+3)=auxtwo(1,2)
            Vtau21(k+3)=auxtwo(2,1)
            Vtau22(k+3)=auxtwo(2,2)
            Vtau11(kp2)=oauxtwo(1,1)
            Vtau12(kp2)=oauxtwo(1,2)
            Vtau21(kp2)=oauxtwo(2,1)
            Vtau22(kp2)=oauxtwo(2,2)
            
            newV11(kp1)=aux22(1,1)
            newV12(kp1)=aux22(1,2)
            newV21(kp1)=aux22(2,1)
            newV22(kp1)=aux22(2,2)
         call split4_for_ds(auxthree,oauxthree,aux33,D)
         newF11(k)=auxthree(1,1)
         newF12(k)=auxthree(1,2)
         newF13(k)=auxthree(1,3)
         newF21(k)=auxthree(2,1)
         newF22(k)=auxthree(2,2)
         newF23(k)=auxthree(2,3)
         newF31(k)=auxthree(3,1)
         newF32(k)=auxthree(3,2)
         newF33(k)=auxthree(3,3)
         Ftau11(kp1)=oauxthree(1,1)
         Ftau12(kp1)=oauxthree(1,2)
         Ftau13(kp1)=oauxthree(1,3)
         Ftau21(kp1)=oauxthree(2,1)
         Ftau22(kp1)=oauxthree(2,2)
         Ftau23(kp1)=oauxthree(2,3)
         Ftau31(kp1)=oauxthree(3,1)
         Ftau32(kp1)=oauxthree(3,2)
         Ftau33(kp1)=oauxthree(3,3)
         Ftau11(kp2)=aux33(1,1)
         Ftau12(kp2)=aux33(1,2)
         Ftau13(kp2)=aux33(1,3)
         Ftau21(kp2)=aux33(2,1)
         Ftau22(kp2)=aux33(2,2)
         Ftau23(kp2)=aux33(2,3)
         Ftau31(kp2)=aux33(3,1)
         Ftau32(kp2)=aux33(3,2)
         Ftau33(kp2)=aux33(3,3)
end do

 ! ***********************
            ! Now the last step(s):
            ! ***********************

            if (defl_size==(nm1))then
             sub32(1,1)=QQ12(nm2)
sub32(1,2)=QQ13(nm2)
sub32(2,1)=QQ22(nm2)
sub32(2,2)=QQ23(nm2)
sub32(3,1)=QQ32(nm2)
sub32(3,2)=QQ33(nm2)
QQ12(nm2)=sub32(1,1)*lastsmallQ(1,1)+sub32(1,2)*lastsmallQ(2,1)
QQ13(nm2)=sub32(1,1)*lastsmallQ(1,2)+sub32(1,2)*lastsmallQ(2,2)
QQ22(nm2)=sub32(2,1)*lastsmallQ(1,1)+sub32(2,2)*lastsmallQ(2,1)
QQ23(nm2)=sub32(2,1)*lastsmallQ(1,2)+sub32(2,2)*lastsmallQ(2,2)
QQ32(nm2)=sub32(3,1)*lastsmallQ(1,1)+sub32(3,2)*lastsmallQ(2,1)
QQ33(nm2)=sub32(3,1)*lastsmallQ(1,2)+sub32(3,2)*lastsmallQ(2,2)
            end if

auxthree=0.d0
auxthree(1,1)=Vtau11(nm2)
 auxthree(1,2)=Vtau12(nm2)
 auxthree(2,1)=Vtau21(nm2)
 auxthree(2,2)=Vtau22(nm2)
auxthree(3,3)=1.d0
sub23=auxthree(2:3,:)
auxthree(2,:)=Vtau11(nm1)*sub23(1,:)+Vtau12(nm1)*sub23(2,:)
auxthree(3,:)=Vtau21(nm1)*sub23(1,:)+Vtau22(nm1)*sub23(2,:)
aux33(1,1)=QQ11(nm2)
aux33(1,2)=QQ21(nm2)
aux33(1,3)=QQ31(nm2)
aux33(2,1)=QQ12(nm2)
aux33(2,2)=QQ22(nm2)
aux33(2,3)=QQ32(nm2)
aux33(3,1)=QQ13(nm2)
aux33(3,2)=QQ23(nm2)
aux33(3,3)=QQ33(nm2)
!Vhat(1:3,1:3)=matmul(aux33,auxthree)
Vhat(1,1)=aux33(1,1)*auxthree(1,1)+aux33(1,2)*auxthree(2,1)+aux33(1,3)*auxthree(3,1)
Vhat(1,2)=aux33(1,1)*auxthree(1,2)+aux33(1,2)*auxthree(2,2)+aux33(1,3)*auxthree(3,2)
Vhat(1,3)=aux33(1,1)*auxthree(1,3)+aux33(1,2)*auxthree(2,3)+aux33(1,3)*auxthree(3,3)
Vhat(2,1)=aux33(2,1)*auxthree(1,1)+aux33(2,2)*auxthree(2,1)+aux33(2,3)*auxthree(3,1)
Vhat(2,2)=aux33(2,1)*auxthree(1,2)+aux33(2,2)*auxthree(2,2)+aux33(2,3)*auxthree(3,2)
Vhat(2,3)=aux33(2,1)*auxthree(1,3)+aux33(2,2)*auxthree(2,3)+aux33(2,3)*auxthree(3,3)
Vhat(3,1)=aux33(3,1)*auxthree(1,1)+aux33(3,2)*auxthree(2,1)+aux33(3,3)*auxthree(3,1)
Vhat(3,2)=aux33(3,1)*auxthree(1,2)+aux33(3,2)*auxthree(2,2)+aux33(3,3)*auxthree(3,2)
Vhat(3,3)=aux33(3,1)*auxthree(1,3)+aux33(3,2)*auxthree(2,3)+aux33(3,3)*auxthree(3,3)


            x=Vhat(1,2:3)
          !  call givens(x,Giv)
          !  ZZ=transpose(Giv)
!auxthree=0.d0
!auxthree(2:3,2:3)=ZZ
!auxthree(1,1)=1.d0
!WW=matmul(Vhat(1:3,1:3),auxthree)
call slimgivens(x,w1,w2)
auxthree=0.d0
!auxthree(2:3,2:3)=ZZ
auxthree(2,2)=w1
auxthree(2,3)=-w2
auxthree(3,2)=w2
auxthree(3,3)=w1
auxthree(1,1)=1.d0
!WW=matmul(Vhat(1:3,1:3),auxthree)
WW(1,1)=Vhat(1,1)
WW(1,2)=Vhat(1,2)*w1+Vhat(1,3)*w2
WW(1,3)=-Vhat(1,2)*w2+Vhat(1,3)*w1
WW(2,1)=Vhat(2,1)
WW(2,2)=Vhat(2,2)*w1+Vhat(2,3)*w2
WW(2,3)=-Vhat(2,2)*w2+Vhat(2,3)*w1
WW(3,1)=Vhat(3,1)
WW(3,2)=Vhat(3,2)*w1+Vhat(3,3)*w2
WW(3,3)=-Vhat(3,2)*w2+Vhat(3,3)*w1

call split2(auxtwo,aux22,WW)
  Vtau11(nm1)=auxtwo(1,1)
 Vtau12(nm1)=auxtwo(1,2)
 Vtau21(nm1)=auxtwo(2,1)
 Vtau22(nm1)=auxtwo(2,2)
 newV11(nm2)=aux22(1,1)
 newV12(nm2)=aux22(1,2)
 newV21(nm2)=aux22(2,1)
 newV22(nm2)=aux22(2,2)
auxfour=0.d0
auxfour(2,2)=QQ11(nm2)
auxfour(2,3)=QQ12(nm2)
auxfour(2,4)=QQ13(nm2)
auxfour(3,2)=QQ21(nm2)
auxfour(3,3)=QQ22(nm2)
auxfour(3,4)=QQ23(nm2)
auxfour(4,2)=QQ31(nm2)
auxfour(4,3)=QQ32(nm2)
auxfour(4,4)=QQ33(nm2)
auxfour(1,1)=1.d0
sub34=auxfour(1:3,:)
auxfour(1,:)=QQ11(n-3)*sub34(1,:)+QQ12(n-3)*sub34(2,:)+QQ13(n-3)*sub34(3,:)
auxfour(2,:)=QQ21(n-3)*sub34(1,:)+QQ22(n-3)*sub34(2,:)+QQ23(n-3)*sub34(3,:)
auxfour(3,:)=QQ31(n-3)*sub34(1,:)+QQ32(n-3)*sub34(2,:)+QQ33(n-3)*sub34(3,:)
sub34=auxfour(2:4,:)
auxfour(2,:)=Ftau11(nm2)*sub34(1,:)+Ftau12(nm2)*sub34(2,:)+Ftau13(nm2)*sub34(3,:)
 auxfour(3,:)=Ftau21(nm2)*sub34(1,:)+Ftau22(nm2)*sub34(2,:)+Ftau23(nm2)*sub34(3,:)
 auxfour(4,:)=Ftau31(nm2)*sub34(1,:)+Ftau32(nm2)*sub34(2,:)+Ftau33(nm2)*sub34(3,:)   
 sub34=auxfour(1:3,:)
auxfour(1,:)=Ftau11(n-3)*sub34(1,:)+Ftau12(n-3)*sub34(2,:)+Ftau13(n-3)*sub34(3,:)
 auxfour(2,:)=Ftau21(n-3)*sub34(1,:)+Ftau22(n-3)*sub34(2,:)+Ftau23(n-3)*sub34(3,:)
 auxfour(3,:)=Ftau31(n-3)*sub34(1,:)+Ftau32(n-3)*sub34(2,:)+Ftau33(n-3)*sub34(3,:)  
Fhat(1:4,1:4)=auxfour
auxfour=0.d0
!auxfour(3:4,3:4)=transpose(ZZ)
auxfour(3,3)=w1
auxfour(3,4)=w2
auxfour(4,3)=-w2
auxfour(4,4)=w1
auxfour(1,1)=1.d0
auxfour(2,2)=1.d0
!DD=matmul(auxfour,Fhat(1:4,1:4))
DD(1,1)=Fhat(1,1)+auxfour(1,2)*Fhat(2,1)+auxfour(1,3)*Fhat(3,1)+auxfour(1,4)*Fhat(4,1)
DD(1,2)=Fhat(1,2)+auxfour(1,2)*Fhat(2,2)+auxfour(1,3)*Fhat(3,2)+auxfour(1,4)*Fhat(4,2)
DD(1,3)=Fhat(1,3)+auxfour(1,2)*Fhat(2,3)+auxfour(1,3)*Fhat(3,3)+auxfour(1,4)*Fhat(4,3)
DD(1,4)=Fhat(1,4)+auxfour(1,2)*Fhat(2,4)+auxfour(1,3)*Fhat(3,4)+auxfour(1,4)*Fhat(4,4)
DD(2,1)=auxfour(2,1)*Fhat(1,1)+Fhat(2,1)+auxfour(2,3)*Fhat(3,1)+auxfour(2,4)*Fhat(4,1)
DD(2,2)=auxfour(2,1)*Fhat(1,2)+Fhat(2,2)+auxfour(2,3)*Fhat(3,2)+auxfour(2,4)*Fhat(4,2)
DD(2,3)=auxfour(2,1)*Fhat(1,3)+Fhat(2,3)+auxfour(2,3)*Fhat(3,3)+auxfour(2,4)*Fhat(4,3)
DD(2,4)=auxfour(2,1)*Fhat(1,4)+Fhat(2,4)+auxfour(2,3)*Fhat(3,4)+auxfour(2,4)*Fhat(4,4)
DD(3,1)=auxfour(3,1)*Fhat(1,1)+auxfour(3,2)*Fhat(2,1)+auxfour(3,3)*Fhat(3,1)+auxfour(3,4)*Fhat(4,1)
DD(3,2)=auxfour(3,1)*Fhat(1,2)+auxfour(3,2)*Fhat(2,2)+auxfour(3,3)*Fhat(3,2)+auxfour(3,4)*Fhat(4,2)
DD(3,3)=auxfour(3,1)*Fhat(1,3)+auxfour(3,2)*Fhat(2,3)+auxfour(3,3)*Fhat(3,3)+auxfour(3,4)*Fhat(4,3)
DD(3,4)=auxfour(3,1)*Fhat(1,4)+auxfour(3,2)*Fhat(2,4)+auxfour(3,3)*Fhat(3,4)+auxfour(3,4)*Fhat(4,4)
DD(4,1)=auxfour(4,1)*Fhat(1,1)+auxfour(4,2)*Fhat(2,1)+auxfour(4,3)*Fhat(3,1)+auxfour(4,4)*Fhat(4,1)
DD(4,2)=auxfour(4,1)*Fhat(1,2)+auxfour(4,2)*Fhat(2,2)+auxfour(4,3)*Fhat(3,2)+auxfour(4,4)*Fhat(4,2)
DD(4,3)=auxfour(4,1)*Fhat(1,3)+auxfour(4,2)*Fhat(2,3)+auxfour(4,3)*Fhat(3,3)+auxfour(4,4)*Fhat(4,3)
DD(4,4)=auxfour(4,1)*Fhat(1,4)+auxfour(4,2)*Fhat(2,4)+auxfour(4,3)*Fhat(3,4)+auxfour(4,4)*Fhat(4,4)

call split3wh(auxthree,oauxthree,DD)
newF11(n-3)=auxthree(1,1)
          newF12(n-3)=auxthree(1,2)
          newF13(n-3)=auxthree(1,3)
          newF21(n-3)=auxthree(2,1)
          newF22(n-3)=auxthree(2,2)
          newF23(n-3)=auxthree(2,3)
          newF31(n-3)=auxthree(3,1)
          newF32(n-3)=auxthree(3,2)
          newF33(n-3)=auxthree(3,3)
          newF11(nm2)=oauxthree(1,1)
          newF12(nm2)=oauxthree(1,2)
          newF13(nm2)=oauxthree(1,3)
          newF21(nm2)=oauxthree(2,1)
          newF22(nm2)=oauxthree(2,2)
          newF23(nm2)=oauxthree(2,3)
          newF31(nm2)=oauxthree(3,1)
          newF32(nm2)=oauxthree(3,2)
          newF33(nm2)=oauxthree(3,3)
newV11(nm1)=Vtau11(nm1)
 newV12(nm1)=Vtau12(nm1)
 newV21(nm1)=Vtau21(nm1)
 newV22(nm1)=Vtau22(nm1)
             newF12(nm1)=0.d0
             newF13(nm1)=0.d0
             newF21(nm1)=0.d0
             newF23(nm1)=0.d0
             newF31(nm1)=0.d0
             newF32(nm1)=0.d0
             newF11(nm1)=1.d0
             newF22(nm1)=1.d0
             newF33(nm1)=1.d0
             newV11(1)=0.d0
             newV12(1)=0.d0
             newV21(1)=0.d0
             newV22(1)=0.d0

elseif(m==nm2)then
write(*,*) "m=nm2"
   do j=1,nm1
newV11(j)=V11(j)
newV12(j)=V12(j)
newV21(j)=V21(j)
newV22(j)=V22(j)
newF11(j)=F11(j)
newF12(j)=F12(j)
newF13(j)=F13(j)
newF21(j)=F21(j)
newF22(j)=F22(j)
newF23(j)=F23(j)
newF31(j)=F31(j)
newF32(j)=F32(j)
newF33(j)=F33(j)
  enddo
!sub32=QQ(:,2:3,nm2)
sub32(1,1)=QQ12(nm2)
sub32(1,2)=QQ13(nm2)
sub32(2,1)=QQ22(nm2)
sub32(2,2)=QQ23(nm2)
sub32(3,1)=QQ32(nm2)
sub32(3,2)=QQ33(nm2)

!QQ(:,2:3,nm2)=matmul(sub32,lastsmallQ)
QQ12(nm2)=sub32(1,1)*lastsmallQ(1,1)+sub32(1,2)*lastsmallQ(2,1)
QQ13(nm2)=sub32(1,1)*lastsmallQ(1,2)+sub32(1,2)*lastsmallQ(2,2)
QQ22(nm2)=sub32(2,1)*lastsmallQ(1,1)+sub32(2,2)*lastsmallQ(2,1)
QQ23(nm2)=sub32(2,1)*lastsmallQ(1,2)+sub32(2,2)*lastsmallQ(2,2)
QQ32(nm2)=sub32(3,1)*lastsmallQ(1,1)+sub32(3,2)*lastsmallQ(2,1)
QQ33(nm2)=sub32(3,1)*lastsmallQ(1,2)+sub32(3,2)*lastsmallQ(2,2)

aux33=0.d0
aux33(1,1)=1.d0
!aux33(2:3,2:3)=V(:,:,nm1)
aux33(2,2)=V11(nm1)
aux33(2,3)=V12(nm1)
aux33(3,2)=V21(nm1)
aux33(3,3)=V22(nm1)

aux32=aux33(:,1:2)
!aux33(:,1:2)=matmul(aux32,V(:,:,nm2))
aux33(1,1)=aux32(1,1)*V11(nm2)+aux32(1,2)*V21(nm2)
aux33(1,2)=aux32(1,1)*V12(nm2)+aux32(1,2)*V22(nm2)
aux33(2,1)=aux32(2,1)*V11(nm2)+aux32(2,2)*V21(nm2)
aux33(2,2)=aux32(2,1)*V12(nm2)+aux32(2,2)*V22(nm2)
aux33(3,1)=aux32(3,1)*V11(nm2)+aux32(3,2)*V21(nm2)
aux33(3,2)=aux32(3,1)*V12(nm2)+aux32(3,2)*V22(nm2)

!auxthree=matmul(transpose(QQ(:,:,nm2)),aux33)
auxthree(1,:)=QQ11(nm2)*aux33(1,:)+QQ21(nm2)*aux33(2,:)+QQ31(nm2)*aux33(3,:)
auxthree(2,:)=QQ12(nm2)*aux33(1,:)+QQ22(nm2)*aux33(2,:)+QQ32(nm2)*aux33(3,:)
auxthree(3,:)=QQ13(nm2)*aux33(1,:)+QQ23(nm2)*aux33(2,:)+QQ33(nm2)*aux33(3,:)

aux44=0.d0
aux44(1,1)=1.d0
!aux44(2:4,2:4)=F(:,:,nm2)
aux44(2,2)=F11(nm2)
aux44(2,3)=F12(nm2)
aux44(2,4)=F13(nm2)
aux44(3,2)=F21(nm2)
aux44(3,3)=F22(nm2)
aux44(3,4)=F23(nm2)
aux44(4,2)=F31(nm2)
aux44(4,3)=F32(nm2)
aux44(4,4)=F33(nm2)

aux34=aux44(1:3,:)
!aux44(1:3,:)=matmul(F(:,:,n-3),aux34)
aux44(1,:)=F11(n-3)*aux34(1,:)+F12(n-3)*aux34(2,:)+F13(n-3)*aux34(3,:)
aux44(2,:)=F21(n-3)*aux34(1,:)+F22(n-3)*aux34(2,:)+F23(n-3)*aux34(3,:)
aux44(3,:)=F31(n-3)*aux34(1,:)+F32(n-3)*aux34(2,:)+F33(n-3)*aux34(3,:)

auxfour=aux44
!auxfour(:,2:4)=matmul(aux44(:,2:4),QQ(:,:,nm2))
auxfour(:,2)=aux44(:,2)*QQ11(nm2)+aux44(:,3)*QQ21(nm2)+aux44(:,4)*QQ31(nm2)
auxfour(:,3)=aux44(:,2)*QQ12(nm2)+aux44(:,3)*QQ22(nm2)+aux44(:,4)*QQ32(nm2)
auxfour(:,4)=aux44(:,2)*QQ13(nm2)+aux44(:,3)*QQ23(nm2)+aux44(:,4)*QQ33(nm2)

x=auxthree(1,2:3)
y=auxfour(3:4,1)
if(abs(x(1))+abs(x(2))>abs(y(1))+abs(y(2)))then
  call givens(x,Gv)
else
  call givens(y,Gv)
endif
aux33=auxthree
auxthree(:,2:3)=matmul(aux33(:,2:3),transpose(Gv))
aux44=auxfour
auxfour(3:4,:)=matmul(Gv,aux44(3:4,:))
if(abs(auxthree(1,3))>10*threshold.or.abs(auxfour(4,1))>10*threshold)then
  write(*,*)"Something wrong in m=nm2 ?"
endif
!call split2(newV(:,:,nm1),newV(:,:,nm2),auxthree)
call split2(auxtwo,aux22,auxthree)
 newV11(nm1)=auxtwo(1,1)
 newV12(nm1)=auxtwo(1,2)
 newV21(nm1)=auxtwo(2,1)
 newV22(nm1)=auxtwo(2,2)
 newV11(nm2)=aux22(1,1)
 newV12(nm2)=aux22(1,2)
 newV21(nm2)=aux22(2,1)
 newV22(nm2)=aux22(2,2)

!call split3wh(newF(:,:,n-3),newF(:,:,nm2),auxfour)
call split3wh(auxthree,oauxthree,auxfour)
          newF11(n-3)=auxthree(1,1)
          newF12(n-3)=auxthree(1,2)
          newF13(n-3)=auxthree(1,3)
          newF21(n-3)=auxthree(2,1)
          newF22(n-3)=auxthree(2,2)
          newF23(n-3)=auxthree(2,3)
          newF31(n-3)=auxthree(3,1)
          newF32(n-3)=auxthree(3,2)
          newF33(n-3)=auxthree(3,3)
          newF11(nm2)=oauxthree(1,1)
          newF12(nm2)=oauxthree(1,2)
          newF13(nm2)=oauxthree(1,3)
          newF21(nm2)=oauxthree(2,1)
          newF22(nm2)=oauxthree(2,2)
          newF23(nm2)=oauxthree(2,3)
          newF31(nm2)=oauxthree(3,1)
          newF32(nm2)=oauxthree(3,2)
          newF33(nm2)=oauxthree(3,3)

elseif(m==n-3)then
  write(*,*) "m=n-3"
       !newV=V
       !newF=F
do j=1,nm1
newV11(j)=V11(j)
newV12(j)=V12(j)
newV21(j)=V21(j)
newV22(j)=V22(j)
newF11(j)=F11(j)
newF12(j)=F12(j)
newF13(j)=F13(j)
newF21(j)=F21(j)
newF22(j)=F22(j)
newF23(j)=F23(j)
newF31(j)=F31(j)
newF32(j)=F32(j)
newF33(j)=F33(j)
  enddo
       aux44=0.d0
       aux44(1,1)=1.d0
       aux44(2,2)=1.d0
       !aux44(3:4,3:4)=V(:,:,nm1)
       aux44(3,3)=V11(nm1)
       aux44(3,4)=V12(nm1)
       aux44(4,3)=V21(nm1)
       aux44(4,4)=V22(nm1)
       
       sub42=aux44(:,2:3)
       !aux44(:,2:3)=matmul(sub42,V(:,:,nm2))
       aux44(:,2)=sub42(:,1)*V11(nm2)+sub42(:,2)*V21(nm2) 
       aux44(:,3)=sub42(:,1)*V12(nm2)+sub42(:,2)*V22(nm2)  
       
       sub42=aux44(:,1:2)
       !aux44(:,1:2)=matmul(sub42,V(:,:,n-3))
       aux44(:,1)=sub42(:,1)*V11(n-3)+sub42(:,2)*V21(n-3) 
       aux44(:,2)=sub42(:,1)*V12(n-3)+sub42(:,2)*V22(n-3)
       
       sub34=aux44(1:3,:)
       !aux44(1:3,:)=matmul(transpose(QQ(:,:,n-3)),sub34)
       aux44(1,:)=QQ11(n-3)*sub34(1,:)+QQ21(n-3)*sub34(2,:)+QQ31(n-3)*sub34(3,:)
       aux44(2,:)=QQ12(n-3)*sub34(1,:)+QQ22(n-3)*sub34(2,:)+QQ32(n-3)*sub34(3,:)
       aux44(3,:)=QQ13(n-3)*sub34(1,:)+QQ23(n-3)*sub34(2,:)+QQ33(n-3)*sub34(3,:)

       if(defl_size==nm1)then
       sub34=aux44(2:4,:)
       !aux44(2:4,:)=matmul(transpose(QQ(:,:,nm2)),sub34)
       aux44(2,:)=QQ11(nm2)*sub34(1,:)+QQ21(nm2)*sub34(2,:)+QQ31(nm2)*sub34(3,:)
       aux44(3,:)=QQ12(nm2)*sub34(1,:)+QQ22(nm2)*sub34(2,:)+QQ32(nm2)*sub34(3,:)
       aux44(4,:)=QQ13(nm2)*sub34(1,:)+QQ23(nm2)*sub34(2,:)+QQ33(nm2)*sub34(3,:)

       sub24=aux44(3:4,:)
       !aux44(3:4,:)=matmul(transpose(lastsmallq),sub24)
       aux44(3,:)=lastsmallq(1,1)*sub24(1,:)+lastsmallq(2,1)*sub24(2,:)
       aux44(4,:)=lastsmallq(1,2)*sub24(1,:)+lastsmallq(2,2)*sub24(2,:)
       
       elseif(defl_size==nm2)then
       sub24=aux44(2:3,:)
       !aux44(2:3,:)=matmul(transpose(lastsmallq),sub24)
       aux44(2,:)=lastsmallq(1,1)*sub24(1,:)+lastsmallq(2,1)*sub24(2,:)
       aux44(3,:)=lastsmallq(1,2)*sub24(1,:)+lastsmallq(2,2)*sub24(2,:)
       else 
         write(*,*)"Something wrong in m=n-3"
       endif  
        auxOC=0.d0
       auxOC(1,1)=1.d0
       auxOC(2,2)=1.d0
       !auxOC(3:5,3:5)=F(:,:,nm2)
       auxOC(3,3)=F11(nm2)
       auxOC(3,4)=F12(nm2)
       auxOC(3,5)=F13(nm2)
       auxOC(4,3)=F21(nm2)
       auxOC(4,4)=F22(nm2)
       auxOC(4,5)=F23(nm2)
       auxOC(5,3)=F31(nm2)
       auxOC(5,4)=F32(nm2)
       auxOC(5,5)=F33(nm2)
       
       sub35=auxOC(2:4,:)
       !auxOC(2:4,:)=matmul(F(:,:,n-3),sub35)
       auxOC(2,:)=F11(n-3)*sub35(1,:)+F12(n-3)*sub35(2,:)+F13(n-3)*sub35(3,:)
       auxOC(3,:)=F21(n-3)*sub35(1,:)+F22(n-3)*sub35(2,:)+F23(n-3)*sub35(3,:)
       auxOC(4,:)=F31(n-3)*sub35(1,:)+F32(n-3)*sub35(2,:)+F33(n-3)*sub35(3,:)
       
       sub35=auxOC(1:3,:)
       !auxOC(1:3,:)=matmul(F(:,:,n-4),sub35)
       auxOC(1,:)=F11(n-4)*sub35(1,:)+F12(n-4)*sub35(2,:)+F13(n-4)*sub35(3,:)
       auxOC(2,:)=F21(n-4)*sub35(1,:)+F22(n-4)*sub35(2,:)+F23(n-4)*sub35(3,:)
       auxOC(3,:)=F31(n-4)*sub35(1,:)+F32(n-4)*sub35(2,:)+F33(n-4)*sub35(3,:)
       
       sub53=auxOC(:,2:4)
       !auxOC(:,2:4)=matmul(sub53,QQ(:,:,n-3))
       auxOC(:,2)=sub53(:,1)*QQ11(n-3)+sub53(:,2)*QQ21(n-3)+sub53(:,3)*QQ31(n-3)
       auxOC(:,3)=sub53(:,1)*QQ12(n-3)+sub53(:,2)*QQ22(n-3)+sub53(:,3)*QQ32(n-3)
       auxOC(:,4)=sub53(:,1)*QQ13(n-3)+sub53(:,2)*QQ23(n-3)+sub53(:,3)*QQ33(n-3)
       
       if(defl_size==nm1)then
       sub53=auxOC(:,3:5)
       !auxOC(:,3:5)=matmul(sub53,QQ(:,:,nm2))
       auxOC(:,3)=sub53(:,1)*QQ11(nm2)+sub53(:,2)*QQ21(nm2)+sub53(:,3)*QQ31(nm2)
       auxOC(:,4)=sub53(:,1)*QQ12(nm2)+sub53(:,2)*QQ22(nm2)+sub53(:,3)*QQ32(nm2)
       auxOC(:,5)=sub53(:,1)*QQ13(nm2)+sub53(:,2)*QQ23(nm2)+sub53(:,3)*QQ33(nm2)
       
       sub52=auxOC(:,4:5)
       auxOC(:,4:5)=matmul(sub52,lastsmallq)
       elseif(defl_size==nm2)then
       sub52=auxOC(:,3:4)
       auxOC(:,3:4)=matmul(sub52,lastsmallq)
       else 
         write(*,*)"Something wrong in m=n-3"
       endif
       auxthree=transpose(aux44(1:3,2:4))
       aux33=auxOC(3:5,1:3)
       call hhbulge3(HH,auxthree,aux33,threshold)
       sub43=aux44(:,2:4)
       aux44(:,2:4)=matmul(sub43,transpose(HH))
       sub35=auxOC(3:5,:)
       auxOC(3:5,:)=matmul(HH,sub35)
       !call split3_for_ds(newV(:,:,nm1),newV(:,:,nm2),newV(:,:,n-3),aux44)
        call split3_for_ds(auxtwo,oauxtwo,aux22,aux44)
             newV11(nm1)=auxtwo(1,1)
             newV12(nm1)=auxtwo(1,2)
             newV21(nm1)=auxtwo(2,1)
             newV22(nm1)=auxtwo(2,2)
             newV11(nm2)=oauxtwo(1,1)
             newV12(nm2)=oauxtwo(1,2)
             newV21(nm2)=oauxtwo(2,1)
             newV22(nm2)=oauxtwo(2,2)
             
             newV11(n-3)=aux22(1,1)
             newV12(n-3)=aux22(1,2)
             newV21(n-3)=aux22(2,1)
             newV22(n-3)=aux22(2,2)
             
       !call split4_for_ds(newF(:,:,n-4),newF(:,:,n-3),newF(:,:,nm2),auxOC)
   call split4_for_ds(auxthree,oauxthree,aux33,auxOC)
          newF11(n-4)=auxthree(1,1)
          newF12(n-4)=auxthree(1,2)
          newF13(n-4)=auxthree(1,3)
          newF21(n-4)=auxthree(2,1)
          newF22(n-4)=auxthree(2,2)
          newF23(n-4)=auxthree(2,3)
          newF31(n-4)=auxthree(3,1)
          newF32(n-4)=auxthree(3,2)
          newF33(n-4)=auxthree(3,3)
          newF11(n-3)=oauxthree(1,1)
          newF12(n-3)=oauxthree(1,2)
          newF13(n-3)=oauxthree(1,3)
          newF21(n-3)=oauxthree(2,1)
          newF22(n-3)=oauxthree(2,2)
          newF23(n-3)=oauxthree(2,3)
          newF31(n-3)=oauxthree(3,1)
          newF32(n-3)=oauxthree(3,2)
          newF33(n-3)=oauxthree(3,3)
          newF11(nm2)=aux33(1,1)
          newF12(nm2)=aux33(1,2)
          newF13(nm2)=aux33(1,3)
          newF21(nm2)=aux33(2,1)
          newF22(nm2)=aux33(2,2)
          newF23(nm2)=aux33(2,3)
          newF31(nm2)=aux33(3,1)
          newF32(nm2)=aux33(3,2)
          newF33(nm2)=aux33(3,3)

elseif((m<n-3).and.(m>1))then

               if (defl_size<nm1)then
                   QQ11(defl_size)=lastsmallQ(1,1)
QQ12(defl_size)=lastsmallQ(1,2)
QQ21(defl_size)=lastsmallQ(2,1)
QQ22(defl_size)=lastsmallQ(2,2)
               endif

               !Vtau=V
                Vtau11(:)=V11(:)
                Vtau12(:)=V12(:)
                Vtau21(:)=V21(:)
                Vtau22(:)=V22(:)
                Ftau11(:)=F11(:)
                Ftau12(:)=F12(:)
                Ftau13(:)=F13(:)
                Ftau21(:)=F21(:)
                Ftau22(:)=F22(:)
                Ftau23(:)=F23(:)
                Ftau31(:)=F31(:)
                Ftau32(:)=F32(:)
                Ftau33(:)=F33(:)
                !newV=V
                newV11(:)=V11(:)
                newV12(:)=V12(:)
                newV21(:)=V21(:)
                newV22(:)=V22(:)
                newF11(:)=F11(:)
                newF12(:)=F12(:)
                newF13(:)=F13(:)
                newF21(:)=F21(:)
                newF22(:)=F22(:)
                newF23(:)=F23(:)
                newF31(:)=F31(:)
                newF32(:)=F32(:)
                newF33(:)=F33(:)
               ! now perform double update step:
               ! compute matrices...

                auxOC=0.d0
               !do j=1,5
               !  auxOC(j,j)=1.d0
               !enddo
               auxOC(3,3)=1.d0 
               auxOC(4,4)=1.d0 
               auxOC(5,5)=1.d0 
               auxOC(1,1)=Vtau11(m)
                auxOC(1,2)=Vtau12(m)
                auxOC(2,1)=Vtau21(m)
                auxOC(2,2)=Vtau22(m)
               sub25=auxOC(2:3,:)
                 auxOC(2,:)=Vtau11(m+1)*sub25(1,:)+Vtau12(m+1)*sub25(2,:)
                auxOC(3,:)=Vtau21(m+1)*sub25(1,:)+Vtau22(m+1)*sub25(2,:)
               sub25=auxOC(3:4,:)
                auxOC(3,:)=V11(m+2)*sub25(1,:)+V12(m+2)*sub25(2,:)
                auxOC(4,:)=V21(m+2)*sub25(1,:)+V22(m+2)*sub25(2,:)
               subauxOC=auxOC(1:3,:)
               aux33(1,1)=QQ11(m)
aux33(1,2)=QQ21(m)
aux33(1,3)=QQ31(m)
aux33(2,1)=QQ12(m)
aux33(2,2)=QQ22(m)
aux33(2,3)=QQ32(m)
aux33(3,1)=QQ13(m)
aux33(3,2)=QQ23(m)
aux33(3,3)=QQ33(m)
              ! auxOC(1:3,:)=matmul(aux33,subauxOC)
auxOC(1,:)=aux33(1,1)*subauxOC(1,:)+aux33(1,2)*subauxOC(2,:)+aux33(1,3)*subauxOC(3,:)
auxOC(2,:)=aux33(2,1)*subauxOC(1,:)+aux33(2,2)*subauxOC(2,:)+aux33(2,3)*subauxOC(3,:)
auxOC(3,:)=aux33(3,1)*subauxOC(1,:)+aux33(3,2)*subauxOC(2,:)+aux33(3,3)*subauxOC(3,:)
               sub25=auxOC(4:5,:)
                auxOC(4,:)=V11(m+3)*sub25(1,:)+V12(m+3)*sub25(2,:)
                auxOC(5,:)=V21(m+3)*sub25(1,:)+V22(m+3)*sub25(2,:)
               subauxOC=auxOC(2:4,:)
               aux33(1,1)=QQ11(m+1)
aux33(1,2)=QQ21(m+1)
aux33(1,3)=QQ31(m+1)
aux33(2,1)=QQ12(m+1)
aux33(2,2)=QQ22(m+1)
aux33(2,3)=QQ32(m+1)
aux33(3,1)=QQ13(m+1)
aux33(3,2)=QQ23(m+1)
aux33(3,3)=QQ33(m+1)
             !  auxOC(2:4,:)=matmul(aux33,subauxOC)
auxOC(2,:)=aux33(1,1)*subauxOC(1,:)+aux33(1,2)*subauxOC(2,:)+aux33(1,3)*subauxOC(3,:)
auxOC(3,:)=aux33(2,1)*subauxOC(1,:)+aux33(2,2)*subauxOC(2,:)+aux33(2,3)*subauxOC(3,:)
auxOC(4,:)=aux33(3,1)*subauxOC(1,:)+aux33(3,2)*subauxOC(2,:)+aux33(3,3)*subauxOC(3,:)
                auxsix=0.d0
               do j=1,6
                 auxsix(j,j)=1.d0
               enddo
               auxsix(1,1)=Ftau11(m-1)
                auxsix(1,2)=Ftau12(m-1)
                auxsix(1,3)=Ftau13(m-1)
                auxsix(2,1)=Ftau21(m-1)
                auxsix(2,2)=Ftau22(m-1)
                auxsix(2,3)=Ftau23(m-1)
                auxsix(3,1)=Ftau31(m-1)
                auxsix(3,2)=Ftau32(m-1)
                auxsix(3,3)=Ftau33(m-1)
               sub63=auxsix(:,2:4)
                auxsix(:,2)=sub63(:,1)*Ftau11(m)+sub63(:,2)*Ftau21(m)+sub63(:,3)*Ftau31(m)
                auxsix(:,3)=sub63(:,1)*Ftau12(m)+sub63(:,2)*Ftau22(m)+sub63(:,3)*Ftau32(m)
                auxsix(:,4)=sub63(:,1)*Ftau13(m)+sub63(:,2)*Ftau23(m)+sub63(:,3)*Ftau33(m)
               sub63=auxsix(:,3:5)
               auxsix(:,3)=sub63(:,1)*F11(m+1)+sub63(:,2)*F21(m+1)+sub63(:,3)*F31(m+1)
                auxsix(:,4)=sub63(:,1)*F12(m+1)+sub63(:,2)*F22(m+1)+sub63(:,3)*F32(m+1)
                auxsix(:,5)=sub63(:,1)*F13(m+1)+sub63(:,2)*F23(m+1)+sub63(:,3)*F33(m+1)
               sub63=auxsix(:,4:6)
                auxsix(:,4)=sub63(:,1)*F11(m+2)+sub63(:,2)*F21(m+2)+sub63(:,3)*F31(m+2)
                auxsix(:,5)=sub63(:,1)*F12(m+2)+sub63(:,2)*F22(m+2)+sub63(:,3)*F32(m+2)
                auxsix(:,6)=sub63(:,1)*F13(m+2)+sub63(:,2)*F23(m+2)+sub63(:,3)*F33(m+2)
               sub63=auxsix(:,2:4)
               auxsix(:,2)=sub63(:,1)*QQ11(m)+sub63(:,2)*QQ21(m)+sub63(:,3)*QQ31(m)
                auxsix(:,3)=sub63(:,1)*QQ12(m)+sub63(:,2)*QQ22(m)+sub63(:,3)*QQ32(m)
                auxsix(:,4)=sub63(:,1)*QQ13(m)+sub63(:,2)*QQ23(m)+sub63(:,3)*QQ33(m)

               aux44=transpose(auxOC(1:4,2:5))
               oaux44=auxsix(3:6,1:4)
               call hhbulge4(auxfour,aux44,oaux44,threshold)
               
               sub54=auxOC(:,2:5)
               aux44=transpose(auxfour)
              ! auxOC(:,2:5)=matmul(sub54,aux44)
auxOC(:,2)=sub54(:,1)*aux44(1,1)+sub54(:,2)*aux44(2,1)+sub54(:,3)*aux44(3,1)+sub54(:,4)*aux44(4,1)
auxOC(:,3)=sub54(:,1)*aux44(1,2)+sub54(:,2)*aux44(2,2)+sub54(:,3)*aux44(3,2)+sub54(:,4)*aux44(4,2)
auxOC(:,4)=sub54(:,1)*aux44(1,3)+sub54(:,2)*aux44(2,3)+sub54(:,3)*aux44(3,3)+sub54(:,4)*aux44(4,3)
auxOC(:,5)=sub54(:,1)*aux44(1,4)+sub54(:,2)*aux44(2,4)+sub54(:,3)*aux44(3,4)+sub54(:,4)*aux44(4,4)

               sub46=auxsix(3:6,:)
             !  auxsix(3:6,:)=matmul(auxfour,sub46)
auxsix(3,:)=auxfour(1,1)*sub46(1,:)+auxfour(1,2)*sub46(2,:)+auxfour(1,3)*sub46(3,:)+auxfour(1,4)*sub46(4,:)
auxsix(4,:)=auxfour(2,1)*sub46(1,:)+auxfour(2,2)*sub46(2,:)+auxfour(2,3)*sub46(3,:)+auxfour(2,4)*sub46(4,:)
auxsix(5,:)=auxfour(3,1)*sub46(1,:)+auxfour(3,2)*sub46(2,:)+auxfour(3,3)*sub46(3,:)+auxfour(3,4)*sub46(4,:)
auxsix(6,:)=auxfour(4,1)*sub46(1,:)+auxfour(4,2)*sub46(2,:)+auxfour(4,3)*sub46(3,:)+auxfour(4,4)*sub46(4,:)


               ! ...and split
               auxV=0.d0
               auxV(1,:)=auxOC(1,1:2)
               auxV(2,1)=auxV(1,2)
               auxV(2,2)=-auxV(1,1)    
               !newV(:,:,m)=auxV;
                 newV11(m)=auxV(1,1)
                newV12(m)=auxV(1,2)
                newV21(m)=auxV(2,1)
                newV22(m)=auxV(2,2)
               sub52=auxOC(:,1:2)
               aux22=transpose(auxV)
             !  auxOC(:,1:2)=matmul(sub52,aux22)
auxOC(:,1)=sub52(:,1)*aux22(1,1)+sub52(:,2)*aux22(2,1)
auxOC(:,2)=sub52(:,1)*aux22(1,2)+sub52(:,2)*aux22(2,2)
               !call split3_for_ds(Vtau(:,:,m+3),Vtau(:,:,m+2),newV(:,:,m+1),auxOC(2:5,2:5))
                 call split3_for_ds(auxtwo,oauxtwo,aux22,auxOC(2:5,2:5))
                Vtau11(m+3)=auxtwo(1,1)
                Vtau12(m+3)=auxtwo(1,2)
                Vtau21(m+3)=auxtwo(2,1)
                Vtau22(m+3)=auxtwo(2,2)
                Vtau11(m+2)=oauxtwo(1,1)
                Vtau12(m+2)=oauxtwo(1,2)
                Vtau21(m+2)=oauxtwo(2,1)
                Vtau22(m+2)=oauxtwo(2,2)
                newV11(m+1)=aux22(1,1)
                newV12(m+1)=aux22(1,2)
                newV21(m+1)=aux22(2,1)
                newV22(m+1)=aux22(2,2)
! from rainyday
auxp=oldp(m:m+4)
 auxp(5)=beta(m+4)
 vec3=auxp(1:3)
! aux33=transpose(QQ(:,:,m))
! auxp(1:3)=matmul(aux33,vec3)
auxp(1)=QQ11(m)*vec3(1)+QQ21(m)*vec3(2)+QQ31(m)*vec3(3)
auxp(2)=QQ12(m)*vec3(1)+QQ22(m)*vec3(2)+QQ32(m)*vec3(3)
auxp(3)=QQ13(m)*vec3(1)+QQ23(m)*vec3(2)+QQ33(m)*vec3(3)

 vec3=auxp(2:4)
 !aux33=transpose(QQ(:,:,m+1))
 !auxp(2:4)=matmul(aux33,vec3)
 auxp(2)=QQ11(m+1)*vec3(1)+QQ21(m+1)*vec3(2)+QQ31(m+1)*vec3(3)
 auxp(3)=QQ12(m+1)*vec3(1)+QQ22(m+1)*vec3(2)+QQ32(m+1)*vec3(3)
 auxp(4)=QQ13(m+1)*vec3(1)+QQ23(m+1)*vec3(2)+QQ33(m+1)*vec3(3)
 
 vec2=auxp(4:5)
 !aux22=transpose(Vtau(:,:,m+3))
 !auxp(4:5)=matmul(aux22,vec2)
auxp(4)=Vtau11(m+3)*vec2(1)+Vtau21(m+3)*vec2(2)
auxp(5)=Vtau12(m+3)*vec2(1)+Vtau22(m+3)*vec2(2)
 
 vec2=auxp(3:4)
! aux22=transpose(Vtau(:,:,m+2))
! auxp(3:4)=matmul(aux22,vec2)
auxp(3)=Vtau11(m+2)*vec2(1)+Vtau21(m+2)*vec2(2)
auxp(4)=Vtau12(m+2)*vec2(1)+Vtau22(m+2)*vec2(2)

 vec2=auxp(2:3)
! aux22=transpose(newV(:,:,m+1))
! auxp(2:3)=matmul(aux22,vec2)
auxp(2)=Vtau11(m+1)*vec2(1)+Vtau21(m+1)*vec2(2)
auxp(3)=Vtau12(m+1)*vec2(1)+Vtau22(m+1)*vec2(2)

 call givens(auxp(1:2),Gv)
 if (abs(auxV(2,1)-Gv(2,1))+abs(auxV(2,2)-Gv(2,2))>10*threshold)then
   sub52=auxOC(:,1:2)
                aux22=auxV
                auxOC(:,1:2)=matmul(sub52,aux22)
    auxV(2,1)=-auxV(1,2)
                auxV(2,2)=auxV(1,1)    
!                newV(:,:,m)=auxV;
 newV11(m)=auxV(1,1)
              newV12(m)=auxV(1,2)
              newV21(m)=auxV(2,1)
              newV22(m)=auxV(2,2)
              
                sub52=auxOC(:,1:2)
                aux22=transpose(auxV)
                auxOC(:,1:2)=matmul(sub52,aux22)
               ! call split3_for_ds(Vtau(:,:,m+3),Vtau(:,:,m+2),newV(:,:,m+1),auxOC(2:5,2:5))
                    call split3_for_ds(auxtwo,oauxtwo,aux22,auxOC(2:5,2:5))
                Vtau11(m+3)=auxtwo(1,1)
                Vtau12(m+3)=auxtwo(1,2)
                Vtau21(m+3)=auxtwo(2,1)
                Vtau22(m+3)=auxtwo(2,2)
                Vtau11(m+2)=oauxtwo(1,1)
                Vtau12(m+2)=oauxtwo(1,2)
                Vtau21(m+2)=oauxtwo(2,1)
                Vtau22(m+2)=oauxtwo(2,2)
                newV11(m+1)=aux22(1,1)
                newV12(m+1)=aux22(1,2)
                newV21(m+1)=aux22(2,1)
                newV22(m+1)=aux22(2,2)
 endif               
   





                
               call householder(GG,auxsix(1:3,1))
                newF11(m-1)=GG(1,1)
                newF12(m-1)=GG(2,1)
                newF13(m-1)=GG(3,1)
                newF21(m-1)=GG(1,2)
                newF22(m-1)=GG(2,2)
                newF23(m-1)=GG(3,2)
                newF31(m-1)=GG(1,3)
                newF32(m-1)=GG(2,3)
                newF33(m-1)=GG(3,3)
               sub36=auxsix(1:3,:)
               auxsix(1:3,:)=matmul(GG,sub36)
               !call split4_for_ds(newF(:,:,m), Ftau(:,:,m+1), Ftau(:,:,m+2),auxsix(2:6,2:6))
   call split4_for_ds(auxthree, oauxthree, aux33,auxsix(2:6,2:6))
          newF11(m)=auxthree(1,1)
          newF12(m)=auxthree(1,2)
          newF13(m)=auxthree(1,3)
          newF21(m)=auxthree(2,1)
          newF22(m)=auxthree(2,2)
          newF23(m)=auxthree(2,3)
          newF31(m)=auxthree(3,1)
          newF32(m)=auxthree(3,2)
          newF33(m)=auxthree(3,3)
          Ftau11(m+1)=oauxthree(1,1)
          Ftau12(m+1)=oauxthree(1,2)
          Ftau13(m+1)=oauxthree(1,3)
          Ftau21(m+1)=oauxthree(2,1)
          Ftau22(m+1)=oauxthree(2,2)
          Ftau23(m+1)=oauxthree(2,3)
          Ftau31(m+1)=oauxthree(3,1)
          Ftau32(m+1)=oauxthree(3,2)
          Ftau33(m+1)=oauxthree(3,3)
          Ftau11(m+2)=aux33(1,1)
          Ftau12(m+2)=aux33(1,2)
          Ftau13(m+2)=aux33(1,3)
          Ftau21(m+2)=aux33(2,1)
          Ftau22(m+2)=aux33(2,2)
          Ftau23(m+2)=aux33(2,3)
          Ftau31(m+2)=aux33(3,1)
          Ftau32(m+2)=aux33(3,2)
          Ftau33(m+2)=aux33(3,3)
               ! now proceed as usual
do k=m+1,n-4
kp1=k+1
kp2=k+2

    
     auxQC(2,1)=Vtau11(kp2)*Vtau21(kp1)
         auxQC(2,2)=Vtau11(kp2)*Vtau22(kp1)
      auxQC(3,1)=V11(k+3)*Vtau21(kp2)*Vtau21(kp1)
         auxQC(3,2)=V11(k+3)*Vtau21(kp2)*Vtau22(kp1)
         auxQC(3,3)=V11(k+3)*Vtau22(kp2)
       
 Vhat(1,1)=QQ11(kp1)*Vtau11(kp1)+QQ21(kp1)*auxQC(2,1)+QQ31(kp1)*auxQC(3,1)
         Vhat(1,2)=QQ11(kp1)*Vtau12(kp1)+QQ21(kp1)*auxQC(2,2)+QQ31(kp1)*auxQC(3,2)
         Vhat(1,3)=QQ21(kp1)*Vtau12(kp2)+QQ31(kp1)*auxQC(3,3)
         Vhat(1,4)=QQ31(kp1)*V12(k+3)
         Vhat(2,1)=QQ12(kp1)*Vtau11(kp1)+QQ22(kp1)*auxQC(2,1)+QQ32(kp1)*auxQC(3,1)
         Vhat(2,2)=QQ12(kp1)*Vtau12(kp1)+QQ22(kp1)*auxQC(2,2)+QQ32(kp1)*auxQC(3,2)
         Vhat(2,3)=QQ22(kp1)*Vtau12(kp2)+QQ32(kp1)*auxQC(3,3)
         Vhat(2,4)=QQ32(kp1)*V12(k+3)
         Vhat(3,1)=QQ13(kp1)*Vtau11(kp1)+QQ23(kp1)*auxQC(2,1)+QQ33(kp1)*auxQC(3,1)
         Vhat(3,2)=QQ13(kp1)*Vtau12(kp1)+QQ23(kp1)*auxQC(2,2)+QQ33(kp1)*auxQC(3,2)
         Vhat(3,3)=QQ23(kp1)*Vtau12(kp2)+QQ33(kp1)*auxQC(3,3)
         Vhat(3,4)=QQ33(kp1)*V12(k+3)
         Vhat(4,1)=V21(k+3)*Vtau21(kp2)*Vtau21(kp1)
         Vhat(4,2)=V21(k+3)*Vtau21(kp2)*Vtau22(kp1)
         Vhat(4,3)=V21(k+3)*Vtau22(kp2)
         Vhat(4,4)=V22(k+3)

auxOC=0.d0
      auxOC(1,1)=QQ11(k)
auxOC(1,2)=QQ12(k)
auxOC(1,3)=QQ13(k)
auxOC(2,1)=QQ21(k)
auxOC(2,2)=QQ22(k)
auxOC(2,3)=QQ23(k) 
       auxOC(3,1)=F11(kp2)*QQ31(k)
      auxOC(3,2)=F11(kp2)*QQ32(k)
      auxOC(3,3)=F11(kp2)*QQ33(k)
      auxOC(3,4)=F12(kp2)
      auxOC(3,5)=F13(kp2)
      auxOC(4,1)=F21(kp2)*QQ31(k)
      auxOC(4,2)=F21(kp2)*QQ32(k)
      auxOC(4,3)=F21(kp2)*QQ33(k)
      auxOC(4,4)=F22(kp2)
      auxOC(4,5)=F23(kp2)
      auxOC(5,1)=F31(kp2)*QQ31(k)
      auxOC(5,2)=F31(kp2)*QQ32(k)
      auxOC(5,3)=F31(kp2)*QQ33(k)
      auxOC(5,4)=F32(kp2)
      auxOC(5,5)=F33(kp2)
      
          subauxOC=auxOC(2:4,:)
      auxOC(2,:)=Ftau11(kp1)*subauxOC(1,:)+Ftau12(kp1)*subauxOC(2,:)+Ftau13(kp1)*subauxOC(3,:)
       auxOC(3,:)=Ftau21(kp1)*subauxOC(1,:)+Ftau22(kp1)*subauxOC(2,:)+Ftau23(kp1)*subauxOC(3,:)
       auxOC(4,:)=Ftau31(kp1)*subauxOC(1,:)+Ftau32(kp1)*subauxOC(2,:)+Ftau33(kp1)*subauxOC(3,:)
      subauxOC=auxOC(1:3,:)
       auxOC(1,:)=Ftau11(k)*subauxOC(1,:)+Ftau12(k)*subauxOC(2,:)+Ftau13(k)*subauxOC(3,:)
       auxOC(2,:)=Ftau21(k)*subauxOC(1,:)+Ftau22(k)*subauxOC(2,:)+Ftau23(k)*subauxOC(3,:)
       auxOC(3,:)=Ftau31(k)*subauxOC(1,:)+Ftau32(k)*subauxOC(2,:)+Ftau33(k)*subauxOC(3,:)  
       Fhat=auxOC 

                bulgethree=Vhat(1:3,2:4)
                aux33=transpose(bulgethree)
                call hhbulge3(HH,aux33,Fhat(3:5,1:3),threshold)
 
W(:,1)=Vhat(:,1)
W(1,2)=Vhat(1,2)*HH(1,1)+Vhat(1,3)*HH(1,2)+Vhat(1,4)*HH(1,3)
W(1,3)=Vhat(1,2)*HH(2,1)+Vhat(1,3)*HH(2,2)+Vhat(1,4)*HH(2,3)
W(1,4)=Vhat(1,2)*HH(3,1)+Vhat(1,3)*HH(3,2)+Vhat(1,4)*HH(3,3)
W(2,2)=Vhat(2,2)*HH(1,1)+Vhat(2,3)*HH(1,2)+Vhat(2,4)*HH(1,3)
W(2,3)=Vhat(2,2)*HH(2,1)+Vhat(2,3)*HH(2,2)+Vhat(2,4)*HH(2,3)
W(2,4)=Vhat(2,2)*HH(3,1)+Vhat(2,3)*HH(3,2)+Vhat(2,4)*HH(3,3)
W(3,2)=Vhat(3,2)*HH(1,1)+Vhat(3,3)*HH(1,2)+Vhat(3,4)*HH(1,3)
W(3,3)=Vhat(3,2)*HH(2,1)+Vhat(3,3)*HH(2,2)+Vhat(3,4)*HH(2,3)
W(3,4)=Vhat(3,2)*HH(3,1)+Vhat(3,3)*HH(3,2)+Vhat(3,4)*HH(3,3)
W(4,2)=Vhat(4,2)*HH(1,1)+Vhat(4,3)*HH(1,2)+Vhat(4,4)*HH(1,3)
W(4,3)=Vhat(4,2)*HH(2,1)+Vhat(4,3)*HH(2,2)+Vhat(4,4)*HH(2,3)
W(4,4)=Vhat(4,2)*HH(3,1)+Vhat(4,3)*HH(3,2)+Vhat(4,4)*HH(3,3)
                
               
                 D(1:2,:)=Fhat(1:2,:)
         D(3,:)=HH(1,1)*Fhat(3,:)+HH(1,2)*Fhat(4,:)+HH(1,3)*Fhat(5,:)
         D(4,:)=HH(2,1)*Fhat(3,:)+HH(2,2)*Fhat(4,:)+HH(2,3)*Fhat(5,:)
         D(5,:)=HH(3,1)*Fhat(3,:)+HH(3,2)*Fhat(4,:)+HH(3,3)*Fhat(5,:)

              !  call split3_for_ds(Vtau(:,:,k+3),Vtau(:,:,kp2),newV(:,:,kp1),W)
 call split3_for_ds(auxtwo,oauxtwo,aux22,W)
                 Vtau11(k+3)=auxtwo(1,1)
                Vtau12(k+3)=auxtwo(1,2)
                Vtau21(k+3)=auxtwo(2,1)
                Vtau22(k+3)=auxtwo(2,2)
                 Vtau11(kp2)=oauxtwo(1,1)
                Vtau12(kp2)=oauxtwo(1,2)
                Vtau21(kp2)=oauxtwo(2,1)
                Vtau22(kp2)=oauxtwo(2,2)
                 newV11(kp1)=aux22(1,1)
                newV12(kp1)=aux22(1,2)
                newV21(kp1)=aux22(2,1)
                newV22(kp1)=aux22(2,2)               

 !call split4_for_ds(newF(:,:,k),Ftau(:,:,kp1),Ftau(:,:,kp2),D)
    call split4_for_ds(auxthree,oauxthree,aux33,D)
          newF11(k)=auxthree(1,1)
          newF12(k)=auxthree(1,2)
          newF13(k)=auxthree(1,3)
          newF21(k)=auxthree(2,1)
          newF22(k)=auxthree(2,2)
          newF23(k)=auxthree(2,3)
          newF31(k)=auxthree(3,1)
          newF32(k)=auxthree(3,2)
          newF33(k)=auxthree(3,3)
          Ftau11(kp1)=oauxthree(1,1)
          Ftau12(kp1)=oauxthree(1,2)
          Ftau13(kp1)=oauxthree(1,3)
          Ftau21(kp1)=oauxthree(2,1)
          Ftau22(kp1)=oauxthree(2,2)
          Ftau23(kp1)=oauxthree(2,3)
          Ftau31(kp1)=oauxthree(3,1)
          Ftau32(kp1)=oauxthree(3,2)
          Ftau33(kp1)=oauxthree(3,3)
          Ftau11(kp2)=aux33(1,1)
          Ftau12(kp2)=aux33(1,2)
          Ftau13(kp2)=aux33(1,3)
          Ftau21(kp2)=aux33(2,1)
          Ftau22(kp2)=aux33(2,2)
          Ftau23(kp2)=aux33(2,3)
          Ftau31(kp2)=aux33(3,1)
          Ftau32(kp2)=aux33(3,2)
          Ftau33(kp2)=aux33(3,3)
 
end do

 ! ***********************
            ! Now the last step(s):
            ! ***********************

            if (defl_size==(nm1))then
              sub32(1,1)=QQ12(nm2)
sub32(1,2)=QQ13(nm2)
sub32(2,1)=QQ22(nm2)
sub32(2,2)=QQ23(nm2)
sub32(3,1)=QQ32(nm2)
sub32(3,2)=QQ33(nm2)
QQ12(nm2)=sub32(1,1)*lastsmallQ(1,1)+sub32(1,2)*lastsmallQ(2,1)
QQ13(nm2)=sub32(1,1)*lastsmallQ(1,2)+sub32(1,2)*lastsmallQ(2,2)
QQ22(nm2)=sub32(2,1)*lastsmallQ(1,1)+sub32(2,2)*lastsmallQ(2,1)
QQ23(nm2)=sub32(2,1)*lastsmallQ(1,2)+sub32(2,2)*lastsmallQ(2,2)
QQ32(nm2)=sub32(3,1)*lastsmallQ(1,1)+sub32(3,2)*lastsmallQ(2,1)
QQ33(nm2)=sub32(3,1)*lastsmallQ(1,2)+sub32(3,2)*lastsmallQ(2,2)
            end if

auxthree=0.d0
auxthree(1,1)=Vtau11(nm2)
 auxthree(1,2)=Vtau12(nm2)
 auxthree(2,1)=Vtau21(nm2)
 auxthree(2,2)=Vtau22(nm2)
auxthree(3,3)=1.d0
sub23=auxthree(2:3,:)
auxthree(2,:)=Vtau11(nm1)*sub23(1,:)+Vtau12(nm1)*sub23(2,:)
 auxthree(3,:)=Vtau21(nm1)*sub23(1,:)+Vtau22(nm1)*sub23(2,:)
aux33(1,1)=QQ11(nm2)
aux33(1,2)=QQ21(nm2)
aux33(1,3)=QQ31(nm2)
aux33(2,1)=QQ12(nm2)
aux33(2,2)=QQ22(nm2)
aux33(2,3)=QQ32(nm2)
aux33(3,1)=QQ13(nm2)
aux33(3,2)=QQ23(nm2)
aux33(3,3)=QQ33(nm2)
 
Vhat(1:3,1:3)=matmul(aux33,auxthree)
x=Vhat(1,2:3)
call givens(x,Giv)
ZZ=transpose(Giv)
auxthree=0.d0
auxthree(2:3,2:3)=ZZ
auxthree(1,1)=1.d0
WW=matmul(Vhat(1:3,1:3),auxthree)
!call split2(Vtau(:,:,nm1),newV(:,:,nm2),WW)
call split2(auxtwo,aux22,WW)
                Vtau11(nm1)=auxtwo(1,1)
                Vtau12(nm1)=auxtwo(1,2)
                Vtau21(nm1)=auxtwo(2,1)
                Vtau22(nm1)=auxtwo(2,2)
 newV11(nm2)=aux22(1,1)
                newV12(nm2)=aux22(1,2)
                newV21(nm2)=aux22(2,1)
                newV22(nm2)=aux22(2,2)
auxfour=0.d0
auxfour(2,2)=QQ11(nm2)
auxfour(2,3)=QQ12(nm2)
auxfour(2,4)=QQ13(nm2)
auxfour(3,2)=QQ21(nm2)
auxfour(3,3)=QQ22(nm2)
auxfour(3,4)=QQ23(nm2)
auxfour(4,2)=QQ31(nm2)
auxfour(4,3)=QQ32(nm2)
auxfour(4,4)=QQ33(nm2)
auxfour(1,1)=1.d0
sub34=auxfour(1:3,:)
auxfour(1,:)=QQ11(n-3)*sub34(1,:)+QQ12(n-3)*sub34(2,:)+QQ13(n-3)*sub34(3,:)
auxfour(2,:)=QQ21(n-3)*sub34(1,:)+QQ22(n-3)*sub34(2,:)+QQ23(n-3)*sub34(3,:)
auxfour(3,:)=QQ31(n-3)*sub34(1,:)+QQ32(n-3)*sub34(2,:)+QQ33(n-3)*sub34(3,:)
 
sub34=auxfour(2:4,:)
auxfour(2,:)=Ftau11(nm2)*sub34(1,:)+Ftau12(nm2)*sub34(2,:)+Ftau13(nm2)*sub34(3,:)
 auxfour(3,:)=Ftau21(nm2)*sub34(1,:)+Ftau22(nm2)*sub34(2,:)+Ftau23(nm2)*sub34(3,:)
 auxfour(4,:)=Ftau31(nm2)*sub34(1,:)+Ftau32(nm2)*sub34(2,:)+Ftau33(nm2)*sub34(3,:)  
sub34=auxfour(1:3,:)
auxfour(1,:)=Ftau11(n-3)*sub34(1,:)+Ftau12(n-3)*sub34(2,:)+Ftau13(n-3)*sub34(3,:)
 auxfour(2,:)=Ftau21(n-3)*sub34(1,:)+Ftau22(n-3)*sub34(2,:)+Ftau23(n-3)*sub34(3,:)
 auxfour(3,:)=Ftau31(n-3)*sub34(1,:)+Ftau32(n-3)*sub34(2,:)+Ftau33(n-3)*sub34(3,:)
 Fhat(1:4,1:4)=auxfour
auxfour=0.d0
auxfour(3:4,3:4)=transpose(ZZ)
auxfour(1,1)=1.d0
auxfour(2,2)=1.d0
DD=matmul(auxfour,Fhat(1:4,1:4))
!call split3wh(newF(:,:,n-3),newF(:,:,nm2),DD)
call split3wh(auxthree,oauxthree,DD)
          newF11(n-3)=auxthree(1,1)
          newF12(n-3)=auxthree(1,2)
          newF13(n-3)=auxthree(1,3)
          newF21(n-3)=auxthree(2,1)
          newF22(n-3)=auxthree(2,2)
          newF23(n-3)=auxthree(2,3)
          newF31(n-3)=auxthree(3,1)
          newF32(n-3)=auxthree(3,2)
          newF33(n-3)=auxthree(3,3)
          newF11(nm2)=oauxthree(1,1)
          newF12(nm2)=oauxthree(1,2)
          newF13(nm2)=oauxthree(1,3)
          newF21(nm2)=oauxthree(2,1)
          newF22(nm2)=oauxthree(2,2)
          newF23(nm2)=oauxthree(2,3)
          newF31(nm2)=oauxthree(3,1)
          newF32(nm2)=oauxthree(3,2)
          newF33(nm2)=oauxthree(3,3)
newV11(nm1)=Vtau11(nm1)
 newV12(nm1)=Vtau12(nm1)
 newV21(nm1)=Vtau21(nm1)
 newV22(nm1)=Vtau22(nm1)
             newF12(nm1)=0.d0
             newF13(nm1)=0.d0
             newF21(nm1)=0.d0
             newF23(nm1)=0.d0
             newF31(nm1)=0.d0
             newF32(nm1)=0.d0
             newF11(nm1)=1.d0
             newF22(nm1)=1.d0
             newF33(nm1)=1.d0
             !newV(:,:,1)=0.d0
             newV11(1)=0.d0
                newV12(1)=0.d0
                newV21(1)=0.d0
                newV22(1)=0.d0
end if  


else   ! this is for short update

if (m==1)then

  newV11(:)=V11(:)
  newV12(:)=V12(:)
  newV21(:)=V21(:)
  newV22(:)=V22(:)
  newF11(:)=F11(:)
  newF12(:)=F12(:)
  newF13(:)=F13(:)
  newF21(:)=F21(:)
  newF22(:)=F22(:)
  newF23(:)=F23(:)
  newF31(:)=F31(:)
  newF32(:)=F32(:)
  newF33(:)=F33(:)

            ! *********
            ! First step:
            !**********

            auxp=oldp(1:5)
            auxp(5)=beta(5)
            vec3=auxp(1:3)
auxp(1)=QQ11(1)*vec3(1)+QQ21(1)*vec3(2)+QQ31(1)*vec3(3)
auxp(2)=QQ12(1)*vec3(1)+QQ22(1)*vec3(2)+QQ32(1)*vec3(3)
auxp(3)=QQ13(1)*vec3(1)+QQ23(1)*vec3(2)+QQ33(1)*vec3(3)

            vec3=auxp(2:4)
auxp(2)=QQ11(2)*vec3(1)+QQ21(2)*vec3(2)+QQ31(2)*vec3(3)
auxp(3)=QQ12(2)*vec3(1)+QQ22(2)*vec3(2)+QQ32(2)*vec3(3)
auxp(4)=QQ13(2)*vec3(1)+QQ23(2)*vec3(2)+QQ33(2)*vec3(3)

            auxF=0.d0
            auxF(1,1)=1.d0
            auxF(2,2)=1.d0
            auxF(3,3)=1.d0
            auxF(4,4)=1.d0
            auxF(5,5)=1.d0

auxF(1,1)=QQ11(1)
auxF(1,2)=QQ12(1)
auxF(1,3)=QQ13(1)
auxF(2,1)=QQ21(1)
auxF(2,2)=QQ22(1)
auxF(2,3)=QQ23(1)
auxF(3,1)=QQ31(1)
auxF(3,2)=QQ32(1)
auxF(3,3)=QQ33(1)
subauxF=auxF(3:5,:)
            auxF(3,:)=F11(3)*subauxF(1,:)+F12(3)*subauxF(2,:)+F13(3)*subauxF(3,:)
             auxF(4,:)=F21(3)*subauxF(1,:)+F22(3)*subauxF(2,:)+F23(3)*subauxF(3,:)
             auxF(5,:)=F31(3)*subauxF(1,:)+F32(3)*subauxF(2,:)+F33(3)*subauxF(3,:)
             subauxF=auxF(2:4,:)
              auxF(2,:)=F11(2)*subauxF(1,:)+F12(2)*subauxF(2,:)+F13(2)*subauxF(3,:)
             auxF(3,:)=F21(2)*subauxF(1,:)+F22(2)*subauxF(2,:)+F23(2)*subauxF(3,:)
             auxF(4,:)=F31(2)*subauxF(1,:)+F32(2)*subauxF(2,:)+F33(2)*subauxF(3,:)
             subauxF=auxF(1:3,:)
               auxF(1,:)=F11(1)*subauxF(1,:)+F12(1)*subauxF(2,:)+F13(1)*subauxF(3,:)
             auxF(2,:)=F21(1)*subauxF(1,:)+F22(1)*subauxF(2,:)+F23(1)*subauxF(3,:)
             auxF(3,:)=F31(1)*subauxF(1,:)+F32(1)*subauxF(2,:)+F33(1)*subauxF(3,:)
             subsubauxF=auxF(2:3,:)
              auxF(2,:)=V11(2)*subsubauxF(1,:)+V12(2)*subsubauxF(2,:)
             auxF(3,:)=V21(2)*subsubauxF(1,:)+V22(2)*subsubauxF(2,:)
            subsubauxF=auxF(3:4,:)
               auxF(3,:)=V11(3)*subsubauxF(1,:)+V12(3)*subsubauxF(2,:)
             auxF(4,:)=V21(3)*subsubauxF(1,:)+V22(3)*subsubauxF(2,:)
            subsubauxF=auxF(4:5,:)
            auxF(4,:)=V11(4)*subsubauxF(1,:)+V12(4)*subsubauxF(2,:)
             auxF(5,:)=V21(4)*subsubauxF(1,:)+V22(4)*subsubauxF(2,:)
            subauxF=auxF(1:3,:)
            aux33(1,1)=QQ11(1)
aux33(1,2)=QQ21(1)
aux33(1,3)=QQ31(1)
aux33(2,1)=QQ12(1)
aux33(2,2)=QQ22(1)
aux33(2,3)=QQ32(1)
aux33(3,1)=QQ13(1)
aux33(3,2)=QQ23(1)
aux33(3,3)=QQ33(1)
            auxF(1:3,:)=matmul(aux33,subauxF)
            subauxF=auxF(2:4,:)
            aux33(1,1)=QQ11(2)
aux33(1,2)=QQ21(2)
aux33(1,3)=QQ31(2)
aux33(2,1)=QQ12(2)
aux33(2,2)=QQ22(2)
aux33(2,3)=QQ32(2)
aux33(3,1)=QQ13(2)
aux33(3,2)=QQ23(2)
aux33(3,3)=QQ33(2)
            auxF(2:4,:)=matmul(aux33,subauxF)

bulgenorm=abs(auxF(5,1))+abs(auxF(5,2))+abs(auxF(4,1))
auxpnorm=abs(auxp(3))+abs(auxp(4))+abs(auxp(5))
           if (bulgenorm>auxpnorm)then
             
            call givens(auxF(4:5,1),Gv)
             Vtau11(4)=Gv(1,1)
             Vtau12(4)=Gv(2,1)
             Vtau21(4)=Gv(1,2)
             Vtau22(4)=Gv(2,2)

            subsubauxF=auxF(4:5,:)
               aux22(1,1)=Vtau11(4)
             aux22(1,2)=Vtau21(4)
             aux22(2,1)=Vtau12(4)
             aux22(2,2)=Vtau22(4)
             auxF(4:5,:)=matmul(aux22,subsubauxF)

            call givens(auxF(3:4,1),Gv)
               Vtau11(3)=Gv(1,1)
             Vtau12(3)=Gv(2,1)
             Vtau21(3)=Gv(1,2)
             Vtau22(3)=Gv(2,2)
vec2=auxp(4:5)
aux22(1,1)=Vtau11(4)
             aux22(1,2)=Vtau21(4)
             aux22(2,1)=Vtau12(4)
             aux22(2,2)=Vtau22(4)
auxp(4:5)=matmul(aux22,vec2)
vec2=auxp(3:4)
aux22(1,1)=Vtau11(3)
             aux22(1,2)=Vtau21(3)
             aux22(2,1)=Vtau12(3)
             aux22(2,2)=Vtau22(3)
            auxp(3:4)=matmul(aux22,vec2)
            call givens(auxp(2:3),Gv)
             Vtau11(2)=Gv(1,1)
             Vtau12(2)=Gv(2,1)
             Vtau21(2)=Gv(1,2)
             Vtau22(2)=Gv(2,2)
              newV11(2)=Gv(1,1)
             newV12(2)=Gv(2,1)
             newV21(2)=Gv(1,2)
             newV22(2)=Gv(2,2)
            
subsubauxF=auxF(3:4,:)
aux22(1,1)=Vtau11(3)
             aux22(1,2)=Vtau21(3)
             aux22(2,1)=Vtau12(3)
             aux22(2,2)=Vtau22(3)
 auxF(3:4,:)=matmul(aux22,subsubauxF)
 subsubauxF=auxF(2:3,:)
 aux22(1,1)=Vtau11(2)
             aux22(1,2)=Vtau21(2)
             aux22(2,1)=Vtau12(2)
             aux22(2,2)=Vtau22(2)
            auxF(2:3,:)=matmul(aux22,subsubauxF)
else
 ! this is the case e.g. when P=ones(n+1,1)
            call givens(auxp(4:5),Gv)
                Vtau11(4)=Gv(1,1)
             Vtau12(4)=Gv(2,1)
             Vtau21(4)=Gv(1,2)
             Vtau22(4)=Gv(2,2)
               vec2=auxp(4:5)
               auxp(4:5)=matmul(Gv,vec2)
             call givens(auxp(3:4),Gv)
                   Vtau11(3)=Gv(1,1)
             Vtau12(3)=Gv(2,1)
             Vtau21(3)=Gv(1,2)
             Vtau22(3)=Gv(2,2)
               vec2=auxp(3:4)
               auxp(3:4)=matmul(Gv,vec2)
             call givens(auxp(2:3),Gv)
                Vtau11(2)=Gv(1,1)
             Vtau12(2)=Gv(2,1)
             Vtau21(2)=Gv(1,2)
             Vtau22(2)=Gv(2,2)
             newV11(2)=Gv(1,1)
             newV12(2)=Gv(2,1)
             newV21(2)=Gv(1,2)
             newV22(2)=Gv(2,2)
           subsubauxF=auxF(4:5,:)
             aux22(1,1)=Vtau11(4)
             aux22(1,2)=Vtau21(4)
             aux22(2,1)=Vtau12(4)
             aux22(2,2)=Vtau22(4)
           auxF(4:5,:)=matmul(aux22,subsubauxF)
           subsubauxF=auxF(3:4,:)
            aux22(1,1)=Vtau11(3)
             aux22(1,2)=Vtau21(3)
             aux22(2,1)=Vtau12(3)
             aux22(2,2)=Vtau22(3)
           auxF(3:4,:)=matmul(aux22,subsubauxF)
           subsubauxF=auxF(2:3,:)
            aux22(1,1)=Vtau11(2)
             aux22(1,2)=Vtau21(2)
             aux22(2,1)=Vtau12(2)
             aux22(2,2)=Vtau22(2)
           auxF(2:3,:)=matmul(aux22,subsubauxF)
 endif
             
         call split4_for_ds(auxthree,oauxthree,aux33,auxF)
           newF11(1)=auxthree(1,1)
          newF12(1)=auxthree(1,2)
          newF13(1)=auxthree(1,3)
          newF21(1)=auxthree(2,1)
          newF22(1)=auxthree(2,2)
          newF23(1)=auxthree(2,3)
          newF31(1)=auxthree(3,1)
          newF32(1)=auxthree(3,2)
          newF33(1)=auxthree(3,3)
          Ftau11(2)=oauxthree(1,1)
          Ftau12(2)=oauxthree(1,2)
          Ftau13(2)=oauxthree(1,3)
          Ftau21(2)=oauxthree(2,1)
          Ftau22(2)=oauxthree(2,2)
          Ftau23(2)=oauxthree(2,3)
          Ftau31(2)=oauxthree(3,1)
          Ftau32(2)=oauxthree(3,2)
          Ftau33(2)=oauxthree(3,3)
          Ftau11(3)=aux33(1,1)
          Ftau12(3)=aux33(1,2)
          Ftau13(3)=aux33(1,3)
          Ftau21(3)=aux33(2,1)
          Ftau22(3)=aux33(2,2)
          Ftau23(3)=aux33(2,3)
          Ftau31(3)=aux33(3,1)
          Ftau32(3)=aux33(3,2)
          Ftau33(3)=aux33(3,3)

            if (defl_size<nm1) then
                 QQ11(defl_size)=lastsmallQ(1,1)
                 QQ12(defl_size)=lastsmallQ(1,2)
                 QQ13(defl_size)=0.d0
                 QQ21(defl_size)=lastsmallQ(2,1)
                 QQ22(defl_size)=lastsmallQ(2,2)
                 QQ23(defl_size)=0.d0
                 QQ31(defl_size)=0.d0
                 QQ32(defl_size)=0.d0
                 QQ33(defl_size)=1.d0
            end if

        !do k=2,n-4
        do k=2,defl_size+4
kp1=k+1
kp2=k+2
      !auxQC=0.d0
     !  auxQC(1,1)=Vtau11(kp1)
     !  auxQC(1,2)=Vtau12(kp1)
     !  auxQC(1,3)=0.d0
     !    auxQC(1,4)=0.d0
    !   auxQC(2,1)=Vtau21(kp1)
    !   auxQC(2,2)=Vtau22(kp1)
    !  auxQC(3,3)=1.d0
    !  auxQC(4,4)=1.d0
    !  subauxQC=auxQC(2:3,:)
      !auxQC(2,:)=Vtau11(kp2)*subauxQC(1,:)+Vtau12(kp2)*subauxQC(2,:)
      auxQC(2,1)=Vtau11(kp2)*Vtau21(kp1)
         auxQC(2,2)=Vtau11(kp2)*Vtau22(kp1)
      !   auxQC(2,3)=Vtau12(kp2)
      !   auxQC(2,4)=0.d0
         
       !auxQC(3,:)=Vtau21(kp2)*subauxQC(1,:)+Vtau22(kp2)*subauxQC(2,:)
      ! auxQC(3,1)=Vtau21(kp2)*Vtau21(kp1)
      !   auxQC(3,2)=Vtau21(kp2)*Vtau22(kp1)
      !   auxQC(3,3)=Vtau22(kp2)
      !   auxQC(3,4)=0.d0
         
      !subauxQC=auxQC(3:4,:) 
      !auxQC(3,:)=V11(k+3)*subauxQC(1,:)+V12(k+3)*subauxQC(2,:)
      auxQC(3,1)=V11(k+3)*Vtau21(kp2)*Vtau21(kp1)
         auxQC(3,2)=V11(k+3)*Vtau21(kp2)*Vtau22(kp1)
         auxQC(3,3)=V11(k+3)*Vtau22(kp2)
       !  auxQC(3,4)=V12(k+3)
         
       !auxQC(4,:)=V21(k+3)*subauxQC(1,:)+V22(k+3)*subauxQC(2,:)
       ! auxQC(4,1)=V21(k+3)*Vtau21(kp2)*Vtau21(kp1)
       !  auxQC(4,2)=V21(k+3)*Vtau21(kp2)*Vtau22(kp1)
       !  auxQC(4,3)=V21(k+3)*Vtau22(kp2)
       !  auxQC(4,4)=V22(k+3)
 Vhat(1,1)=QQ11(kp1)*Vtau11(kp1)+QQ21(kp1)*auxQC(2,1)+QQ31(kp1)*auxQC(3,1)
         Vhat(1,2)=QQ11(kp1)*Vtau12(kp1)+QQ21(kp1)*auxQC(2,2)+QQ31(kp1)*auxQC(3,2)
         Vhat(1,3)=QQ21(kp1)*Vtau12(kp2)+QQ31(kp1)*auxQC(3,3)
         Vhat(1,4)=QQ31(kp1)*V12(k+3)
         Vhat(2,1)=QQ12(kp1)*Vtau11(kp1)+QQ22(kp1)*auxQC(2,1)+QQ32(kp1)*auxQC(3,1)
         Vhat(2,2)=QQ12(kp1)*Vtau12(kp1)+QQ22(kp1)*auxQC(2,2)+QQ32(kp1)*auxQC(3,2)
         Vhat(2,3)=QQ22(kp1)*Vtau12(kp2)+QQ32(kp1)*auxQC(3,3)
         Vhat(2,4)=QQ32(kp1)*V12(k+3)
         Vhat(3,1)=QQ13(kp1)*Vtau11(kp1)+QQ23(kp1)*auxQC(2,1)+QQ33(kp1)*auxQC(3,1)
         Vhat(3,2)=QQ13(kp1)*Vtau12(kp1)+QQ23(kp1)*auxQC(2,2)+QQ33(kp1)*auxQC(3,2)
         Vhat(3,3)=QQ23(kp1)*Vtau12(kp2)+QQ33(kp1)*auxQC(3,3)
         Vhat(3,4)=QQ33(kp1)*V12(k+3)
         !Vhat(4,:)=auxQC(4,:)
         Vhat(4,1)=V21(k+3)*Vtau21(kp2)*Vtau21(kp1)
         Vhat(4,2)=V21(k+3)*Vtau21(kp2)*Vtau22(kp1)
         Vhat(4,3)=V21(k+3)*Vtau22(kp2)
         Vhat(4,4)=V22(k+3)        
 
!Vhat(1,1)=QQ11(kp1)*auxQC(1,1)+QQ21(kp1)*auxQC(2,1)+QQ31(kp1)*auxQC(3,1)
!         Vhat(1,2)=QQ11(kp1)*auxQC(1,2)+QQ21(kp1)*auxQC(2,2)+QQ31(kp1)*auxQC(3,2)
!         Vhat(1,3)=QQ11(kp1)*auxQC(1,3)+QQ21(kp1)*auxQC(2,3)+QQ31(kp1)*auxQC(3,3)
!         Vhat(1,4)=QQ11(kp1)*auxQC(1,4)+QQ21(kp1)*auxQC(2,4)+QQ31(kp1)*auxQC(3,4)
!         Vhat(2,1)=QQ12(kp1)*auxQC(1,1)+QQ22(kp1)*auxQC(2,1)+QQ32(kp1)*auxQC(3,1)
 !        Vhat(2,2)=QQ12(kp1)*auxQC(1,2)+QQ22(kp1)*auxQC(2,2)+QQ32(kp1)*auxQC(3,2)
 !        Vhat(2,3)=QQ12(kp1)*auxQC(1,3)+QQ22(kp1)*auxQC(2,3)+QQ32(kp1)*auxQC(3,3)
 !        Vhat(2,4)=QQ12(kp1)*auxQC(1,4)+QQ22(kp1)*auxQC(2,4)+QQ32(kp1)*auxQC(3,4)
 !        Vhat(3,1)=QQ13(kp1)*auxQC(1,1)+QQ23(kp1)*auxQC(2,1)+QQ33(kp1)*auxQC(3,1)
 !        Vhat(3,2)=QQ13(kp1)*auxQC(1,2)+QQ23(kp1)*auxQC(2,2)+QQ33(kp1)*auxQC(3,2)
 !        Vhat(3,3)=QQ13(kp1)*auxQC(1,3)+QQ23(kp1)*auxQC(2,3)+QQ33(kp1)*auxQC(3,3)
 !        Vhat(3,4)=QQ13(kp1)*auxQC(1,4)+QQ23(kp1)*auxQC(2,4)+QQ33(kp1)*auxQC(3,4)
 !        Vhat(4,:)=auxQC(4,:)

auxOC=0.d0
      auxOC(1,1)=QQ11(k)
auxOC(1,2)=QQ12(k)
auxOC(1,3)=QQ13(k)
auxOC(2,1)=QQ21(k)
auxOC(2,2)=QQ22(k)
auxOC(2,3)=QQ23(k)
!auxOC(3,1)=QQ31(k)
!auxOC(3,2)=QQ32(k)
!auxOC(3,3)=QQ33(k)
!      auxOC(5,5)=1.d0
!      auxOC(4,4)=1.d0
      !subauxOC=auxOC(3:5,:)
    !auxOC(3,:)=F11(kp2)*subauxOC(1,:)+F12(kp2)*subauxOC(2,:)+F13(kp2)*subauxOC(3,:)
     !  auxOC(4,:)=F21(kp2)*subauxOC(1,:)+F22(kp2)*subauxOC(2,:)+F23(kp2)*subauxOC(3,:)
     !  auxOC(5,:)=F31(kp2)*subauxOC(1,:)+F32(kp2)*subauxOC(2,:)+F33(kp2)*subauxOC(3,:)  
      auxOC(3,1)=F11(kp2)*QQ31(k)
      auxOC(3,2)=F11(kp2)*QQ32(k)
      auxOC(3,3)=F11(kp2)*QQ33(k)
      auxOC(3,4)=F12(kp2)
      auxOC(3,5)=F13(kp2)
      auxOC(4,1)=F21(kp2)*QQ31(k)
      auxOC(4,2)=F21(kp2)*QQ32(k)
      auxOC(4,3)=F21(kp2)*QQ33(k)
      auxOC(4,4)=F22(kp2)
      auxOC(4,5)=F23(kp2)
      auxOC(5,1)=F31(kp2)*QQ31(k)
      auxOC(5,2)=F31(kp2)*QQ32(k)
      auxOC(5,3)=F31(kp2)*QQ33(k)
      auxOC(5,4)=F32(kp2)
      auxOC(5,5)=F33(kp2)
      
       subauxOC=auxOC(2:4,:)
       
        auxOC(2,:)=Ftau11(kp1)*subauxOC(1,:)+Ftau12(kp1)*subauxOC(2,:)+Ftau13(kp1)*subauxOC(3,:)
       auxOC(3,:)=Ftau21(kp1)*subauxOC(1,:)+Ftau22(kp1)*subauxOC(2,:)+Ftau23(kp1)*subauxOC(3,:)
       auxOC(4,:)=Ftau31(kp1)*subauxOC(1,:)+Ftau32(kp1)*subauxOC(2,:)+Ftau33(kp1)*subauxOC(3,:)  
       subauxOC=auxOC(1:3,:)
       
       auxOC(1,:)=Ftau11(k)*subauxOC(1,:)+Ftau12(k)*subauxOC(2,:)+Ftau13(k)*subauxOC(3,:)
       auxOC(2,:)=Ftau21(k)*subauxOC(1,:)+Ftau22(k)*subauxOC(2,:)+Ftau23(k)*subauxOC(3,:)
       auxOC(3,:)=Ftau31(k)*subauxOC(1,:)+Ftau32(k)*subauxOC(2,:)+Ftau33(k)*subauxOC(3,:)    
       Fhat=auxOC  

               ! bulgethree=Vhat(1:3,2:4)
               ! aux33=transpose(bulgethree)
aux33(1,1)=Vhat(1,2)
aux33(1,2)=Vhat(2,2)
aux33(1,3)=Vhat(3,2)
aux33(2,1)=Vhat(1,3)
aux33(2,2)=Vhat(2,3)
aux33(2,3)=Vhat(3,3)
aux33(3,1)=Vhat(1,4)
aux33(3,2)=Vhat(2,4)
aux33(3,3)=Vhat(3,4)
                call hhbulge3(HH,aux33,Fhat(3:5,1:3),threshold)
               
!W=0.d0
!W(1,1)=1.d0
!W(2:4,2:4)=transpose(HH)
!subW=W;
!W=matmul(Vhat,subW)
W(:,1)=Vhat(:,1)
W(1,2)=Vhat(1,2)*HH(1,1)+Vhat(1,3)*HH(1,2)+Vhat(1,4)*HH(1,3)
W(1,3)=Vhat(1,2)*HH(2,1)+Vhat(1,3)*HH(2,2)+Vhat(1,4)*HH(2,3)
W(1,4)=Vhat(1,2)*HH(3,1)+Vhat(1,3)*HH(3,2)+Vhat(1,4)*HH(3,3)
W(2,2)=Vhat(2,2)*HH(1,1)+Vhat(2,3)*HH(1,2)+Vhat(2,4)*HH(1,3)
W(2,3)=Vhat(2,2)*HH(2,1)+Vhat(2,3)*HH(2,2)+Vhat(2,4)*HH(2,3)
W(2,4)=Vhat(2,2)*HH(3,1)+Vhat(2,3)*HH(3,2)+Vhat(2,4)*HH(3,3)
W(3,2)=Vhat(3,2)*HH(1,1)+Vhat(3,3)*HH(1,2)+Vhat(3,4)*HH(1,3)
W(3,3)=Vhat(3,2)*HH(2,1)+Vhat(3,3)*HH(2,2)+Vhat(3,4)*HH(2,3)
W(3,4)=Vhat(3,2)*HH(3,1)+Vhat(3,3)*HH(3,2)+Vhat(3,4)*HH(3,3)
W(4,2)=Vhat(4,2)*HH(1,1)+Vhat(4,3)*HH(1,2)+Vhat(4,4)*HH(1,3)
W(4,3)=Vhat(4,2)*HH(2,1)+Vhat(4,3)*HH(2,2)+Vhat(4,4)*HH(2,3)
W(4,4)=Vhat(4,2)*HH(3,1)+Vhat(4,3)*HH(3,2)+Vhat(4,4)*HH(3,3)
                
 
 D(1:2,:)=Fhat(1:2,:)
         D(3,:)=HH(1,1)*Fhat(3,:)+HH(1,2)*Fhat(4,:)+HH(1,3)*Fhat(5,:)
         D(4,:)=HH(2,1)*Fhat(3,:)+HH(2,2)*Fhat(4,:)+HH(2,3)*Fhat(5,:)
         D(5,:)=HH(3,1)*Fhat(3,:)+HH(3,2)*Fhat(4,:)+HH(3,3)*Fhat(5,:)

  call split3_for_ds(auxtwo,oauxtwo,aux22,W)
   Vtau11(k+3)=auxtwo(1,1)
             Vtau12(k+3)=auxtwo(1,2)
             Vtau21(k+3)=auxtwo(2,1)
             Vtau22(k+3)=auxtwo(2,2)
             Vtau11(kp2)=oauxtwo(1,1)
             Vtau12(kp2)=oauxtwo(1,2)
             Vtau21(kp2)=oauxtwo(2,1)
             Vtau22(kp2)=oauxtwo(2,2)
             newV11(kp1)=aux22(1,1)
             newV12(kp1)=aux22(1,2)
             newV21(kp1)=aux22(2,1)
             newV22(kp1)=aux22(2,2)
  call split4_for_ds(auxthree,oauxthree,aux33,D)
    newF11(k)=auxthree(1,1)
          newF12(k)=auxthree(1,2)
          newF13(k)=auxthree(1,3)
          newF21(k)=auxthree(2,1)
          newF22(k)=auxthree(2,2)
          newF23(k)=auxthree(2,3)
          newF31(k)=auxthree(3,1)
          newF32(k)=auxthree(3,2)
          newF33(k)=auxthree(3,3)
          Ftau11(kp1)=oauxthree(1,1)
          Ftau12(kp1)=oauxthree(1,2)
          Ftau13(kp1)=oauxthree(1,3)
          Ftau21(kp1)=oauxthree(2,1)
          Ftau22(kp1)=oauxthree(2,2)
          Ftau23(kp1)=oauxthree(2,3)
          Ftau31(kp1)=oauxthree(3,1)
          Ftau32(kp1)=oauxthree(3,2)
          Ftau33(kp1)=oauxthree(3,3)
          Ftau11(kp2)=aux33(1,1)
          Ftau12(kp2)=aux33(1,2)
          Ftau13(kp2)=aux33(1,3)
          Ftau21(kp2)=aux33(2,1)
          Ftau22(kp2)=aux33(2,2)
          Ftau23(kp2)=aux33(2,3)
          Ftau31(kp2)=aux33(3,1)
          Ftau32(kp2)=aux33(3,2)
          Ftau33(kp2)=aux33(3,3)
end do

elseif(m<n-3)then

!$$$$$$                if (defl_size<nm1)then
                   QQ11(defl_size)=lastsmallQ(1,1)
QQ12(defl_size)=lastsmallQ(1,2)
QQ21(defl_size)=lastsmallQ(2,1)
QQ22(defl_size)=lastsmallQ(2,2)
!$$$$$$                endif

!if(m>4)then
!  write(*,*)"let's see"
!endif

               !Vtau=V
                Vtau11(:)=V11(:)
                Vtau12(:)=V12(:)
                Vtau21(:)=V21(:)
                Vtau22(:)=V22(:)
                Ftau11(:)=F11(:)
                Ftau12(:)=F12(:)
                Ftau13(:)=F13(:)
                Ftau21(:)=F21(:)
                Ftau22(:)=F22(:)
                Ftau23(:)=F23(:)
                Ftau31(:)=F31(:)
                Ftau32(:)=F32(:)
                Ftau33(:)=F33(:)
                !newV=V
                newV11(:)=V11(:)
                newV12(:)=V12(:)
                newV21(:)=V21(:)
                newV22(:)=V22(:)
                newF11(:)=F11(:)
                newF12(:)=F12(:)
                newF13(:)=F13(:)
                newF21(:)=F21(:)
                newF22(:)=F22(:)
                newF23(:)=F23(:)
                newF31(:)=F31(:)
                newF32(:)=F32(:)
                newF33(:)=F33(:)
               ! now perform double update step:
               ! compute matrices...

                auxOC=0.d0
               do j=1,5
                 auxOC(j,j)=1.d0
               enddo
               auxOC(1,1)=Vtau11(m)
                auxOC(1,2)=Vtau12(m)
                auxOC(2,1)=Vtau21(m)
                auxOC(2,2)=Vtau22(m)
               sub25=auxOC(2:3,:)
                 auxOC(2,:)=Vtau11(m+1)*sub25(1,:)+Vtau12(m+1)*sub25(2,:)
                auxOC(3,:)=Vtau21(m+1)*sub25(1,:)+Vtau22(m+1)*sub25(2,:)
               sub25=auxOC(3:4,:)
                auxOC(3,:)=V11(m+2)*sub25(1,:)+V12(m+2)*sub25(2,:)
                auxOC(4,:)=V21(m+2)*sub25(1,:)+V22(m+2)*sub25(2,:)
               subauxOC=auxOC(1:3,:)
               aux33(1,1)=QQ11(m)
aux33(1,2)=QQ21(m)
aux33(1,3)=QQ31(m)
aux33(2,1)=QQ12(m)
aux33(2,2)=QQ22(m)
aux33(2,3)=QQ32(m)
aux33(3,1)=QQ13(m)
aux33(3,2)=QQ23(m)
aux33(3,3)=QQ33(m)
               auxOC(1:3,:)=matmul(aux33,subauxOC)
               sub25=auxOC(4:5,:)
                auxOC(4,:)=V11(m+3)*sub25(1,:)+V12(m+3)*sub25(2,:)
                auxOC(5,:)=V21(m+3)*sub25(1,:)+V22(m+3)*sub25(2,:)
               subauxOC=auxOC(2:4,:)
               aux33(1,1)=QQ11(m+1)
aux33(1,2)=QQ21(m+1)
aux33(1,3)=QQ31(m+1)
aux33(2,1)=QQ12(m+1)
aux33(2,2)=QQ22(m+1)
aux33(2,3)=QQ32(m+1)
aux33(3,1)=QQ13(m+1)
aux33(3,2)=QQ23(m+1)
aux33(3,3)=QQ33(m+1)
               auxOC(2:4,:)=matmul(aux33,subauxOC)

                auxsix=0.d0
               do j=1,6
                 auxsix(j,j)=1.d0
               enddo
               auxsix(1,1)=Ftau11(m-1)
                auxsix(1,2)=Ftau12(m-1)
                auxsix(1,3)=Ftau13(m-1)
                auxsix(2,1)=Ftau21(m-1)
                auxsix(2,2)=Ftau22(m-1)
                auxsix(2,3)=Ftau23(m-1)
                auxsix(3,1)=Ftau31(m-1)
                auxsix(3,2)=Ftau32(m-1)
                auxsix(3,3)=Ftau33(m-1)
               sub63=auxsix(:,2:4)
                auxsix(:,2)=sub63(:,1)*Ftau11(m)+sub63(:,2)*Ftau21(m)+sub63(:,3)*Ftau31(m)
                auxsix(:,3)=sub63(:,1)*Ftau12(m)+sub63(:,2)*Ftau22(m)+sub63(:,3)*Ftau32(m)
                auxsix(:,4)=sub63(:,1)*Ftau13(m)+sub63(:,2)*Ftau23(m)+sub63(:,3)*Ftau33(m)
               sub63=auxsix(:,3:5)
               auxsix(:,3)=sub63(:,1)*F11(m+1)+sub63(:,2)*F21(m+1)+sub63(:,3)*F31(m+1)
                auxsix(:,4)=sub63(:,1)*F12(m+1)+sub63(:,2)*F22(m+1)+sub63(:,3)*F32(m+1)
                auxsix(:,5)=sub63(:,1)*F13(m+1)+sub63(:,2)*F23(m+1)+sub63(:,3)*F33(m+1)
               sub63=auxsix(:,4:6)
                auxsix(:,4)=sub63(:,1)*F11(m+2)+sub63(:,2)*F21(m+2)+sub63(:,3)*F31(m+2)
                auxsix(:,5)=sub63(:,1)*F12(m+2)+sub63(:,2)*F22(m+2)+sub63(:,3)*F32(m+2)
                auxsix(:,6)=sub63(:,1)*F13(m+2)+sub63(:,2)*F23(m+2)+sub63(:,3)*F33(m+2)
               sub63=auxsix(:,2:4)
               auxsix(:,2)=sub63(:,1)*QQ11(m)+sub63(:,2)*QQ21(m)+sub63(:,3)*QQ31(m)
                auxsix(:,3)=sub63(:,1)*QQ12(m)+sub63(:,2)*QQ22(m)+sub63(:,3)*QQ32(m)
                auxsix(:,4)=sub63(:,1)*QQ13(m)+sub63(:,2)*QQ23(m)+sub63(:,3)*QQ33(m)

               aux44=transpose(auxOC(1:4,2:5))
               oaux44=auxsix(3:6,1:4)
               call hhbulge4(auxfour,aux44,oaux44,threshold)
               
               sub54=auxOC(:,2:5)
               aux44=transpose(auxfour)
               auxOC(:,2:5)=matmul(sub54,aux44)
               sub46=auxsix(3:6,:)
               auxsix(3:6,:)=matmul(auxfour,sub46)

               ! ...and split
               auxV=0.d0
               auxV(1,:)=auxOC(1,1:2)
               auxV(2,1)=auxV(1,2)   ! here one may choose different signs!!!!
               auxV(2,2)=-auxV(1,1)    
               !newV(:,:,m)=auxV;
                 newV11(m)=auxV(1,1)
                newV12(m)=auxV(1,2)
                newV21(m)=auxV(2,1)
                newV22(m)=auxV(2,2)
               sub52=auxOC(:,1:2)
               aux22=transpose(auxV)
               auxOC(:,1:2)=matmul(sub52,aux22)
               !call split3_for_ds(Vtau(:,:,m+3),Vtau(:,:,m+2),newV(:,:,m+1),auxOC(2:5,2:5))
                 call split3_for_ds(auxtwo,oauxtwo,aux22,auxOC(2:5,2:5))
                Vtau11(m+3)=auxtwo(1,1)
                Vtau12(m+3)=auxtwo(1,2)
                Vtau21(m+3)=auxtwo(2,1)
                Vtau22(m+3)=auxtwo(2,2)
                Vtau11(m+2)=oauxtwo(1,1)
                Vtau12(m+2)=oauxtwo(1,2)
                Vtau21(m+2)=oauxtwo(2,1)
                Vtau22(m+2)=oauxtwo(2,2)
                newV11(m+1)=aux22(1,1)
                newV12(m+1)=aux22(1,2)
                newV21(m+1)=aux22(2,1)
                newV22(m+1)=aux22(2,2)

! from rainyday
auxp=oldp(m:m+4)
 auxp(5)=beta(m+4)
 vec3=auxp(1:3)
! aux33=transpose(QQ(:,:,m))
! auxp(1:3)=matmul(aux33,vec3)
auxp(1)=QQ11(m)*vec3(1)+QQ21(m)*vec3(2)+QQ31(m)*vec3(3)
auxp(2)=QQ12(m)*vec3(1)+QQ22(m)*vec3(2)+QQ32(m)*vec3(3)
auxp(3)=QQ13(m)*vec3(1)+QQ23(m)*vec3(2)+QQ33(m)*vec3(3)

 vec3=auxp(2:4)
 !aux33=transpose(QQ(:,:,m+1))
 !auxp(2:4)=matmul(aux33,vec3)
 auxp(2)=QQ11(m+1)*vec3(1)+QQ21(m+1)*vec3(2)+QQ31(m+1)*vec3(3)
 auxp(3)=QQ12(m+1)*vec3(1)+QQ22(m+1)*vec3(2)+QQ32(m+1)*vec3(3)
 auxp(4)=QQ13(m+1)*vec3(1)+QQ23(m+1)*vec3(2)+QQ33(m+1)*vec3(3)
 
 vec2=auxp(4:5)
 !aux22=transpose(Vtau(:,:,m+3))
 !auxp(4:5)=matmul(aux22,vec2)
auxp(4)=Vtau11(m+3)*vec2(1)+Vtau21(m+3)*vec2(2)
auxp(5)=Vtau12(m+3)*vec2(1)+Vtau22(m+3)*vec2(2)
 
 vec2=auxp(3:4)
! aux22=transpose(Vtau(:,:,m+2))
! auxp(3:4)=matmul(aux22,vec2)
auxp(3)=Vtau11(m+2)*vec2(1)+Vtau21(m+2)*vec2(2)
auxp(4)=Vtau12(m+2)*vec2(1)+Vtau22(m+2)*vec2(2)

 vec2=auxp(2:3)
! aux22=transpose(newV(:,:,m+1))
! auxp(2:3)=matmul(aux22,vec2)
auxp(2)=Vtau11(m+1)*vec2(1)+Vtau21(m+1)*vec2(2)
auxp(3)=Vtau12(m+1)*vec2(1)+Vtau22(m+1)*vec2(2)

 call slimgivens(auxp(1:2),w1,w2)
 if (abs(auxV(2,1)+w2)+abs(auxV(2,2)-w1)>10*threshold)then
   sub52=auxOC(:,1:2)
                aux22=auxV
                auxOC(:,1:2)=matmul(sub52,aux22)
    auxV(2,1)=-auxV(1,2)
                auxV(2,2)=auxV(1,1)    
                !newV(:,:,m)=auxV
                newV11(m)=auxV(1,1)
              newV12(m)=auxV(1,2)
              newV21(m)=auxV(2,1)
              newV22(m)=auxV(2,2)
                
                sub52=auxOC(:,1:2)
                aux22=transpose(auxV)
                auxOC(:,1:2)=matmul(sub52,aux22)
               ! call split3_for_ds(Vtau(:,:,m+3),Vtau(:,:,m+2),newV(:,:,m+1),auxOC(2:5,2:5))
                    call split3_for_ds(auxtwo,oauxtwo,aux22,auxOC(2:5,2:5))
                Vtau11(m+3)=auxtwo(1,1)
                Vtau12(m+3)=auxtwo(1,2)
                Vtau21(m+3)=auxtwo(2,1)
                Vtau22(m+3)=auxtwo(2,2)
                Vtau11(m+2)=oauxtwo(1,1)
                Vtau12(m+2)=oauxtwo(1,2)
                Vtau21(m+2)=oauxtwo(2,1)
                Vtau22(m+2)=oauxtwo(2,2)
                newV11(m+1)=aux22(1,1)
                newV12(m+1)=aux22(1,2)
                newV21(m+1)=aux22(2,1)
                newV22(m+1)=aux22(2,2)
 endif       


                
               call householder(GG,auxsix(1:3,1))
                newF11(m-1)=GG(1,1)
                newF12(m-1)=GG(2,1)
                newF13(m-1)=GG(3,1)
                newF21(m-1)=GG(1,2)
                newF22(m-1)=GG(2,2)
                newF23(m-1)=GG(3,2)
                newF31(m-1)=GG(1,3)
                newF32(m-1)=GG(2,3)
                newF33(m-1)=GG(3,3)
               sub36=auxsix(1:3,:)
               auxsix(1:3,:)=matmul(GG,sub36)
               !call split4_for_ds(newF(:,:,m), Ftau(:,:,m+1), Ftau(:,:,m+2),auxsix(2:6,2:6))
   call split4_for_ds(auxthree, oauxthree, aux33,auxsix(2:6,2:6))
          newF11(m)=auxthree(1,1)
          newF12(m)=auxthree(1,2)
          newF13(m)=auxthree(1,3)
          newF21(m)=auxthree(2,1)
          newF22(m)=auxthree(2,2)
          newF23(m)=auxthree(2,3)
          newF31(m)=auxthree(3,1)
          newF32(m)=auxthree(3,2)
          newF33(m)=auxthree(3,3)
          Ftau11(m+1)=oauxthree(1,1)
          Ftau12(m+1)=oauxthree(1,2)
          Ftau13(m+1)=oauxthree(1,3)
          Ftau21(m+1)=oauxthree(2,1)
          Ftau22(m+1)=oauxthree(2,2)
          Ftau23(m+1)=oauxthree(2,3)
          Ftau31(m+1)=oauxthree(3,1)
          Ftau32(m+1)=oauxthree(3,2)
          Ftau33(m+1)=oauxthree(3,3)
          Ftau11(m+2)=aux33(1,1)
          Ftau12(m+2)=aux33(1,2)
          Ftau13(m+2)=aux33(1,3)
          Ftau21(m+2)=aux33(2,1)
          Ftau22(m+2)=aux33(2,2)
          Ftau23(m+2)=aux33(2,3)
          Ftau31(m+2)=aux33(3,1)
          Ftau32(m+2)=aux33(3,2)
          Ftau33(m+2)=aux33(3,3)
               ! now proceed as usual
do k=m+1,defl_size+4
kp1=k+1
kp2=k+2
     ! auxQC=0.d0
     !  auxQC(1,1)=Vtau11(kp1)
     !  auxQC(1,2)=Vtau12(kp1)
     !  auxQC(1,3)=0.d0
     !    auxQC(1,4)=0.d0
!       auxQC(2,1)=Vtau21(kp1)
!       auxQC(2,2)=Vtau22(kp1)
!      auxQC(3,3)=1.d0
!      auxQC(4,4)=1.d0
!      subauxQC=auxQC(2:3,:)
     !auxQC(2,:)=Vtau11(kp2)*subauxQC(1,:)+Vtau12(kp2)*subauxQC(2,:)
     auxQC(2,1)=Vtau11(kp2)*Vtau21(kp1)
         auxQC(2,2)=Vtau11(kp2)*Vtau22(kp1)
      !   auxQC(2,3)=Vtau12(kp2)
      !   auxQC(2,4)=0.d0
         
       !auxQC(3,:)=Vtau21(kp2)*subauxQC(1,:)+Vtau22(kp2)*subauxQC(2,:)
    !   auxQC(3,1)=Vtau21(kp2)*Vtau21(kp1)
    !     auxQC(3,2)=Vtau21(kp2)*Vtau22(kp1)
    !     auxQC(3,3)=Vtau22(kp2)
    !     auxQC(3,4)=0.d0
         
      !subauxQC=auxQC(3:4,:)   
      !auxQC(3,:)=V11(k+3)*subauxQC(1,:)+V12(k+3)*subauxQC(2,:)
      auxQC(3,1)=V11(k+3)*Vtau21(kp2)*Vtau21(kp1)
         auxQC(3,2)=V11(k+3)*Vtau21(kp2)*Vtau22(kp1)
         auxQC(3,3)=V11(k+3)*Vtau22(kp2)
       !  auxQC(3,4)=V12(k+3)
         
       !auxQC(4,:)=V21(k+3)*subauxQC(1,:)+V22(k+3)*subauxQC(2,:)
        !auxQC(4,1)=V21(k+3)*Vtau21(kp2)*Vtau21(kp1)
        ! auxQC(4,2)=V21(k+3)*Vtau21(kp2)*Vtau22(kp1)
        ! auxQC(4,3)=V21(k+3)*Vtau22(kp2)
        ! auxQC(4,4)=V22(k+3)
          Vhat(1,1)=QQ11(kp1)*Vtau11(kp1)+QQ21(kp1)*auxQC(2,1)+QQ31(kp1)*auxQC(3,1)
         Vhat(1,2)=QQ11(kp1)*Vtau12(kp1)+QQ21(kp1)*auxQC(2,2)+QQ31(kp1)*auxQC(3,2)
         Vhat(1,3)=QQ21(kp1)*Vtau12(kp2)+QQ31(kp1)*auxQC(3,3)
         Vhat(1,4)=QQ31(kp1)*V12(k+3)
         Vhat(2,1)=QQ12(kp1)*Vtau11(kp1)+QQ22(kp1)*auxQC(2,1)+QQ32(kp1)*auxQC(3,1)
         Vhat(2,2)=QQ12(kp1)*Vtau12(kp1)+QQ22(kp1)*auxQC(2,2)+QQ32(kp1)*auxQC(3,2)
         Vhat(2,3)=QQ22(kp1)*Vtau12(kp2)+QQ32(kp1)*auxQC(3,3)
         Vhat(2,4)=QQ32(kp1)*V12(k+3)
         Vhat(3,1)=QQ13(kp1)*Vtau11(kp1)+QQ23(kp1)*auxQC(2,1)+QQ33(kp1)*auxQC(3,1)
         Vhat(3,2)=QQ13(kp1)*Vtau12(kp1)+QQ23(kp1)*auxQC(2,2)+QQ33(kp1)*auxQC(3,2)
         Vhat(3,3)=QQ23(kp1)*Vtau12(kp2)+QQ33(kp1)*auxQC(3,3)
         Vhat(3,4)=QQ33(kp1)*V12(k+3)
         !Vhat(4,:)=auxQC(4,:)
         Vhat(4,1)=V21(k+3)*Vtau21(kp2)*Vtau21(kp1)
         Vhat(4,2)=V21(k+3)*Vtau21(kp2)*Vtau22(kp1)
         Vhat(4,3)=V21(k+3)*Vtau22(kp2)
         Vhat(4,4)=V22(k+3)
         
!Vhat(1,1)=QQ11(kp1)*auxQC(1,1)+QQ21(kp1)*auxQC(2,1)+QQ31(kp1)*auxQC(3,1)
!         Vhat(1,2)=QQ11(kp1)*auxQC(1,2)+QQ21(kp1)*auxQC(2,2)+QQ31(kp1)*auxQC(3,2)
!         Vhat(1,3)=QQ11(kp1)*auxQC(1,3)+QQ21(kp1)*auxQC(2,3)+QQ31(kp1)*auxQC(3,3)
!         Vhat(1,4)=QQ11(kp1)*auxQC(1,4)+QQ21(kp1)*auxQC(2,4)+QQ31(kp1)*auxQC(3,4)
!         Vhat(2,1)=QQ12(kp1)*auxQC(1,1)+QQ22(kp1)*auxQC(2,1)+QQ32(kp1)*auxQC(3,1)
!         Vhat(2,2)=QQ12(kp1)*auxQC(1,2)+QQ22(kp1)*auxQC(2,2)+QQ32(kp1)*auxQC(3,2)
!         Vhat(2,3)=QQ12(kp1)*auxQC(1,3)+QQ22(kp1)*auxQC(2,3)+QQ32(kp1)*auxQC(3,3)
!         Vhat(3,1)=QQ13(kp1)*auxQC(1,1)+QQ23(kp1)*auxQC(2,1)+QQ33(kp1)*auxQC(3,1)
!         Vhat(3,2)=QQ13(kp1)*auxQC(1,2)+QQ23(kp1)*auxQC(2,2)+QQ33(kp1)*auxQC(3,2)
!         Vhat(3,3)=QQ13(kp1)*auxQC(1,3)+QQ23(kp1)*auxQC(2,3)+QQ33(kp1)*auxQC(3,3)
!         Vhat(3,4)=QQ13(kp1)*auxQC(1,4)+QQ23(kp1)*auxQC(2,4)+QQ33(kp1)*auxQC(3,4)
!         Vhat(4,:)=auxQC(4,:)

auxOC=0.d0
      auxOC(1,1)=QQ11(k)
auxOC(1,2)=QQ12(k)
auxOC(1,3)=QQ13(k)
auxOC(2,1)=QQ21(k)
auxOC(2,2)=QQ22(k)
auxOC(2,3)=QQ23(k)

      auxOC(3,1)=F11(kp2)*QQ31(k)
      auxOC(3,2)=F11(kp2)*QQ32(k)
      auxOC(3,3)=F11(kp2)*QQ33(k)
      auxOC(3,4)=F12(kp2)
      auxOC(3,5)=F13(kp2)
      auxOC(4,1)=F21(kp2)*QQ31(k)
      auxOC(4,2)=F21(kp2)*QQ32(k)
      auxOC(4,3)=F21(kp2)*QQ33(k)
      auxOC(4,4)=F22(kp2)
      auxOC(4,5)=F23(kp2)
      !auxOC(5,1)=F31(kp2)*QQ31(k)
      !auxOC(5,2)=F31(kp2)*QQ32(k)
      !auxOC(5,3)=F31(kp2)*QQ33(k)
      !auxOC(5,4)=F32(kp2)
      !auxOC(5,5)=F33(kp2)
      
          subauxOC=auxOC(2:4,:)
       auxOC(2,:)=Ftau11(kp1)*subauxOC(1,:)+Ftau12(kp1)*subauxOC(2,:)+Ftau13(kp1)*subauxOC(3,:)
       auxOC(3,:)=Ftau21(kp1)*subauxOC(1,:)+Ftau22(kp1)*subauxOC(2,:)+Ftau23(kp1)*subauxOC(3,:)
       auxOC(4,:)=Ftau31(kp1)*subauxOC(1,:)+Ftau32(kp1)*subauxOC(2,:)+Ftau33(kp1)*subauxOC(3,:)
      subauxOC=auxOC(1:3,:)
       auxOC(1,:)=Ftau11(k)*subauxOC(1,:)+Ftau12(k)*subauxOC(2,:)+Ftau13(k)*subauxOC(3,:)
       auxOC(2,:)=Ftau21(k)*subauxOC(1,:)+Ftau22(k)*subauxOC(2,:)+Ftau23(k)*subauxOC(3,:)
       auxOC(3,:)=Ftau31(k)*subauxOC(1,:)+Ftau32(k)*subauxOC(2,:)+Ftau33(k)*subauxOC(3,:)  
       !Fhat=auxOC
       Fhat(1:4,:)=auxOC(1:4,:)
      Fhat(5,1)=F31(kp2)*QQ31(k)
      Fhat(5,2)=F31(kp2)*QQ32(k)
      Fhat(5,3)=F31(kp2)*QQ33(k)
      Fhat(5,4)=F32(kp2)
      Fhat(5,5)=F33(kp2) 

                bulgethree=Vhat(1:3,2:4)
                aux33=transpose(bulgethree)
                call hhbulge3(HH,aux33,Fhat(3:5,1:3),threshold)
            

W(:,1)=Vhat(:,1)
W(1,2)=Vhat(1,2)*HH(1,1)+Vhat(1,3)*HH(1,2)+Vhat(1,4)*HH(1,3)
W(1,3)=Vhat(1,2)*HH(2,1)+Vhat(1,3)*HH(2,2)+Vhat(1,4)*HH(2,3)
W(1,4)=Vhat(1,2)*HH(3,1)+Vhat(1,3)*HH(3,2)+Vhat(1,4)*HH(3,3)
W(2,2)=Vhat(2,2)*HH(1,1)+Vhat(2,3)*HH(1,2)+Vhat(2,4)*HH(1,3)
W(2,3)=Vhat(2,2)*HH(2,1)+Vhat(2,3)*HH(2,2)+Vhat(2,4)*HH(2,3)
W(2,4)=Vhat(2,2)*HH(3,1)+Vhat(2,3)*HH(3,2)+Vhat(2,4)*HH(3,3)
W(3,2)=Vhat(3,2)*HH(1,1)+Vhat(3,3)*HH(1,2)+Vhat(3,4)*HH(1,3)
W(3,3)=Vhat(3,2)*HH(2,1)+Vhat(3,3)*HH(2,2)+Vhat(3,4)*HH(2,3)
W(3,4)=Vhat(3,2)*HH(3,1)+Vhat(3,3)*HH(3,2)+Vhat(3,4)*HH(3,3)
W(4,2)=Vhat(4,2)*HH(1,1)+Vhat(4,3)*HH(1,2)+Vhat(4,4)*HH(1,3)
W(4,3)=Vhat(4,2)*HH(2,1)+Vhat(4,3)*HH(2,2)+Vhat(4,4)*HH(2,3)
W(4,4)=Vhat(4,2)*HH(3,1)+Vhat(4,3)*HH(3,2)+Vhat(4,4)*HH(3,3)
                
            
 D(1:2,:)=Fhat(1:2,:)
         D(3,:)=HH(1,1)*Fhat(3,:)+HH(1,2)*Fhat(4,:)+HH(1,3)*Fhat(5,:)
         D(4,:)=HH(2,1)*Fhat(3,:)+HH(2,2)*Fhat(4,:)+HH(2,3)*Fhat(5,:)
         D(5,:)=HH(3,1)*Fhat(3,:)+HH(3,2)*Fhat(4,:)+HH(3,3)*Fhat(5,:)
         
              !  call split3_for_ds(Vtau(:,:,k+3),Vtau(:,:,kp2),newV(:,:,kp1),W)
 call split3_for_ds(auxtwo,oauxtwo,aux22,W)
                 Vtau11(k+3)=auxtwo(1,1)
                Vtau12(k+3)=auxtwo(1,2)
                Vtau21(k+3)=auxtwo(2,1)
                Vtau22(k+3)=auxtwo(2,2)
                 Vtau11(kp2)=oauxtwo(1,1)
                Vtau12(kp2)=oauxtwo(1,2)
                Vtau21(kp2)=oauxtwo(2,1)
                Vtau22(kp2)=oauxtwo(2,2)
                 newV11(kp1)=aux22(1,1)
                newV12(kp1)=aux22(1,2)
                newV21(kp1)=aux22(2,1)
                newV22(kp1)=aux22(2,2)               

 !call split4_for_ds(newF(:,:,k),Ftau(:,:,kp1),Ftau(:,:,kp2),D)
    call split4_for_ds(auxthree,oauxthree,aux33,D)
          newF11(k)=auxthree(1,1)
          newF12(k)=auxthree(1,2)
          newF13(k)=auxthree(1,3)
          newF21(k)=auxthree(2,1)
          newF22(k)=auxthree(2,2)
          newF23(k)=auxthree(2,3)
          newF31(k)=auxthree(3,1)
          newF32(k)=auxthree(3,2)
          newF33(k)=auxthree(3,3)
          Ftau11(kp1)=oauxthree(1,1)
          Ftau12(kp1)=oauxthree(1,2)
          Ftau13(kp1)=oauxthree(1,3)
          Ftau21(kp1)=oauxthree(2,1)
          Ftau22(kp1)=oauxthree(2,2)
          Ftau23(kp1)=oauxthree(2,3)
          Ftau31(kp1)=oauxthree(3,1)
          Ftau32(kp1)=oauxthree(3,2)
          Ftau33(kp1)=oauxthree(3,3)
          Ftau11(kp2)=aux33(1,1)
          Ftau12(kp2)=aux33(1,2)
          Ftau13(kp2)=aux33(1,3)
          Ftau21(kp2)=aux33(2,1)
          Ftau22(kp2)=aux33(2,2)
          Ftau23(kp2)=aux33(2,3)
          Ftau31(kp2)=aux33(3,1)
          Ftau32(kp2)=aux33(3,2)
          Ftau33(kp2)=aux33(3,3)
 
end do


end if  

endif    ! this was for the short update  

p=newp
q=newq
V11(:)=newV11(:)
V12(:)=newV12(:)
V21(:)=newV21(:)
V22(:)=newV22(:)
F11(:)=newF11(:)
F12(:)=newF12(:)
F13(:)=newF13(:)
F21(:)=newF21(:)
F22(:)=newF22(:)
F23(:)=newF23(:)
F31(:)=newF31(:)
F32(:)=newF32(:)
F33(:)=newF33(:)

enddo iterate
enddo approx

! now, how to compute the first eigenvalues? 
lmo=defl_size+1

!$$$$$$  write(*,*)"lmo=",lmo
!$$$$$$  allocate(lastmatrix(lmo,lmo))
!$$$$$$ 
!$$$$$$ ! Use the previously computed V and F to update the
!$$$$$$   ! quasiseparable representation (step 1 in Thm. 3.1).
!$$$$$$   !h(:,1:nm2)=F(1:2,1,1:nm2)
   h1(1:nm2)=F11(1:nm2)
   h2(1:nm2)=F21(1:nm2)
 
 !b(:,:,1:nm2)=F(1:2,2:3,1:nm2)
b11(1:nm2)=F12(1:nm2)
     b12(1:nm2)=F13(1:nm2)
     b21(1:nm2)=F22(1:nm2)
     b22(1:nm2)=F23(1:nm2)
 
 !h(:,nm1)=F(1:2,1,nm1)
  h1(nm1)=F11(nm1)
     h2(nm1)=F21(nm1)

       b11(nm1)=F12(nm1)
     b12(nm1)=0.d0
     b21(nm1)=F22(nm1)
     b22(nm1)=0.d0
 !b(:,1,nm1)=F(1:2,2,nm1)
 !b(:,2,nm1)=0.d0
 h1(n)=1.d0
 h2(n)=0.d0  
 gamma1(1)=0.d0
 gamma2(1)=1.d0
 g1(1)=1.d0
 g2(1)=0.d0
 do k=1,nm2
       !auxMM(1,1:3)=matmul(gamma(k,:),F(1:2,:,k))
 auxMM(1,1)=gamma1(k)*F11(k)+gamma2(k)*F21(k)
        auxMM(1,2)=gamma1(k)*F12(k)+gamma2(k)*F22(k)
        auxMM(1,3)=gamma1(k)*F13(k)+gamma2(k)*F23(k)
        !auxMM(2,:)=F(3,:,k)
        auxMM(2,1)=F31(k)
        auxMM(2,2)=F32(k)
        auxMM(2,3)=F33(k)

!       MM=matmul(V(:,:,k+1),auxMM)
  MM(1,:)=V11(k+1)*auxMM(1,:)+V12(k+1)*auxMM(2,:)
        MM(2,:)=V21(k+1)*auxMM(1,:)+V22(k+1)*auxMM(2,:)
        
       sigma(k)=MM(1,1)
       !g(k+1,:)=MM(1,2:3)
       g1(k+1)=MM(1,2)
       g2(k+1)=MM(1,3)
       !gamma(k+1,:)=MM(2,2:3)
       gamma1(k+1)=MM(2,2)
       gamma2(k+1)=MM(2,3)
 enddo
 sigma(nm1)=(gamma1(nm1)*h1(nm1))+(gamma2(nm1)*h2(nm1))
 !g(n,:)=matmul(gamma(nm1,:),b(:,:,nm1))
  g1(n)=gamma1(nm1)*b11(nm1)+gamma2(nm1)*b21(nm1)
     g2(n)=gamma1(nm1)*b12(nm1)+gamma2(nm1)*b22(nm1)

if(lmo==1)then
 myeigre(1)=g1(1)*h1(1)+g2(1)*h2(1)-p(1)*q(1)
 myeigim(1)=0.d0
endif
if(lmo==2)then
 a_final(1,1)=diagonals(defl_size)
    auxvec(1)=b11(defl_size)*h1(defl_size+1)+b12(defl_size)*h2(defl_size+1)
    auxvec(2)=b21(defl_size)*h1(defl_size+1)+b22(defl_size)*h2(defl_size+1)
    a_final(1,2)=g1(defl_size)*auxvec(1)+g2(defl_size)*auxvec(2)-p(defl_size)*q(defl_size+1)
    a_final(2,1)=subdiag(defl_size)
    a_final(2,2)=diagonals(defl_size+1)
    s=abs(a_final(1,1))+abs(a_final(2,1))+abs(a_final(1,2))+abs(a_final(2,2))
    na_final=a_final/s  ! normalize a_final
    tr=(na_final(1,1)+na_final(2,2))/(2.d0)
    det=(na_final(1,1)-tr)*(na_final(2,2)-tr)-na_final(1,2)*na_final(2,1)
    myeigre(defl_size+1)=tr*s;
    myeigre(defl_size)=myeigre(defl_size+1)
    rtdisc=sqrt(abs(det))
    if (det>0.d0)then    ! complex conjugate eigenvalues
      myeigim(defl_size)=rtdisc*s
      myeigim(defl_size+1)=-myeigim(defl_size)
    else
      write(*,*)"Pair of real roots" 
    myeigre(defl_size+1)=myeigre(defl_size+1)+rtdisc*s
    myeigre(defl_size)=myeigre(defl_size)-rtdisc*s 
    myeigim(1)=0.d0
    myeigim(2)=0.d0
    endif
endif     

if(lmo==3)then
 ! allocate(auxAA(3,3))
   auxAA(1,1)=g1(1)*h1(1)+g2(1)*h2(1)-p(1)*q(1)
auxAA(2,2)=g1(2)*h1(2)+g2(2)*h2(2)-p(2)*q(2)
auxAA(3,3)=g1(3)*h1(3)+g2(3)*h2(3)-p(3)*q(3)
auxAA(2,1)=sigma(1)-p(2)*q(1)
auxAA(3,2)=sigma(2)-p(3)*q(2)
auxAA(3,1)=0.d0
x(1)=b11(2)*h1(3)+b12(2)*h2(3)
x(2)=b21(2)*h1(3)+b22(2)*h2(3)
auxAA(2,3)=g1(2)*x(1)+g2(2)*x(2)-p(2)*q(3)
y(1)=b11(1)*x(1)+b12(1)*x(2)
y(2)=b21(1)*x(1)+b22(1)*x(2)
auxAA(1,3)=g1(1)*y(1)+g2(1)*y(2)-p(1)*q(3)
x(1)=b11(1)*h1(2)+b12(1)*h2(2)
x(2)=b21(1)*h1(2)+b22(1)*h2(2)
auxAA(1,2)=g1(1)*x(1)+g2(1)*x(2)-p(1)*q(2)

three:do j=1,30
if (abs(auxAA(2,1))<threshold)then
  write(*,*)"1+2"    
     s=abs(auxAA(2,2))+abs(auxAA(3,2))+abs(auxAA(2,3))+abs(auxAA(3,3))
     na_final=auxAA(2:3,2:3)/s  ! normalize a_final
     tr=(na_final(1,1)+na_final(2,2))/(2.d0)
     det=(na_final(1,1)-tr)*(na_final(2,2)-tr)-na_final(1,2)*na_final(2,1)
     myeigre(3)=tr*s;
     myeigre(2)=myeigre(3)
     rtdisc=sqrt(abs(det))
     if (det>0.d0)then    ! complex conjugate eigenvalues
       myeigim(2)=rtdisc*s
       myeigim(3)=-myeigim(2)
     else
     myeigre(3)=myeigre(3)+rtdisc*s
     myeigre(2)=myeigre(2)-rtdisc*s 
     endif
     myeigre(1)=auxAA(1,1)
     myeigim(1)=0.d0
  exit three
endif
if (abs(auxAA(3,2))<threshold)then
  write(*,*)"2+1"
     myeigre(3)=auxAA(3,3)
     myeigim(3)=0.d0
     s=abs(auxAA(1,1))+abs(auxAA(2,1))+abs(auxAA(1,2))+abs(auxAA(2,2))
     na_final=auxAA(1:2,1:2)/s  ! normalize a_final
     tr=(na_final(1,1)+na_final(2,2))/(2.d0)
     det=(na_final(1,1)-tr)*(na_final(2,2)-tr)-na_final(1,2)*na_final(2,1)
     myeigre(2)=tr*s;
     myeigre(1)=myeigre(2)
     rtdisc=sqrt(abs(det))
     if (det>0.d0)then    ! complex conjugate eigenvalues
       myeigim(1)=rtdisc*s
       myeigim(2)=-myeigim(1)
     else
     myeigre(2)=myeigre(2)+rtdisc*s
     myeigre(1)=myeigre(1)-rtdisc*s 
     endif
  exit three
endif
nrm(1)=((auxAA(3,3)-auxAA(1,1))*(auxAA(2,2)-auxAA(1,1))-auxAA(2,3)*auxAA(3,2))/auxAA(2,1)+auxAA(1,2)
  nrm(2)=auxAA(2,2)-auxAA(1,1)-(auxAA(3,3)-auxAA(1,1))-(auxAA(2,2)-auxAA(1,1))
  nrm(3)=auxAA(3,2)
  ! normalize nrm as suggested in NR
  nrs=abs(nrm(1))+abs(nrm(2))+abs(nrm(3))
  nrm=nrm/nrs
  call householder(GG,nrm)
  auxthree=auxAA
  auxAA=matmul(GG,auxthree)
  auxthree=matmul(auxAA,transpose(GG))
  x=auxthree(2:3,1)
  call givens(x,Gv)
  auxAA=auxthree
  auxAA(2:3,:)=matmul(Gv,auxthree(2:3,:))
  auxthree=auxAA
  auxAA(:,2:3)=matmul(auxthree(:,2:3),transpose(Gv))
  if (j==20) then
    write(*,*)"random shift needed"
  endif
enddo three
endif

end subroutine begg_ds



subroutine givens(x,G)
 ! Dato x=[x1; x2], calcola la matrice di Givens G
 ! 2x2 tale che Gx ha il secondo elemento nullo.
 implicit none
 real(kind(1d0))   :: x(2)
 real(kind(1d0))  :: G(2,2)
  real(kind(1d0)) :: s,w1,w2
  G(1,2)=0.d0
  G(2,1)=0.d0
  G(1,1)=1.d0
  G(2,2)=1.d0
          ! if (abs(x(2))>0.d0)then
      if (x(2)/=0.d0)then
                  if (dabs(x(1)) >= dabs(x(2))) then
          s = dsqrt(1.0d0 + (x(2)/x(1))**2) * dabs(x(1))
      else
          s = dsqrt(1.0d0 + (x(1)/x(2))**2) * dabs(x(2))
      endif
             w1=x(1)/s
             w2=x(2)/s
             G(1,1)=w1
             G(1,2)=w2
             G(2,1)=-w2
             G(2,2)=w1
            endif
 return
end subroutine givens

subroutine slimgivens(x,w1,w2)
 ! Fornisce solo w1 e w2 anziche' G.
 implicit none
 real(kind(1d0))   :: x(2)
  real(kind(1d0)) :: s,w1,w2
  w1=1.d0
  w2=0.d0
           !if (abs(x(2))>0.d0)then
      if (x(2)/=0.d0)then
                  if (dabs(x(1)) >= dabs(x(2))) then
          s = dsqrt(1.0d0 + (x(2)/x(1))**2) * dabs(x(1))
      else
          s = dsqrt(1.0d0 + (x(1)/x(2))**2) * dabs(x(2))
      endif
             w1=x(1)/s
             w2=x(2)/s
            endif
 return
end subroutine slimgivens

subroutine slimplanerot(x,w1,w2,s)
 ! Fornisce solo w1 e w2 anziche' G.
 implicit none
 real(kind(1d0))   :: x(2)
  real(kind(1d0)) :: s,w1,w2
 ! w1=1.d0
 ! w2=0.d0
           if (abs(x(2))>0.d0)then
                  if (dabs(x(1)) >= dabs(x(2))) then
          s = dsqrt(1.0d0 + (x(2)/x(1))**2) * dabs(x(1))
      else
          s = dsqrt(1.0d0 + (x(1)/x(2))**2) * dabs(x(2))
      endif
             w1=x(1)/s
             w2=x(2)/s
        else
	if (x(1) >= 0.0d0) then
			s	= x(1)
			w1	= 1.0d0
		else
			s	= -x(1)
			w1	= -1.0d0
		endif
		w2	= 0.0d0
            endif
 return
end subroutine slimplanerot


subroutine split2(A,B,W)
 ! factorizes W
 implicit none
 real(kind(1d0)) :: W(3,3)
 real(kind(1d0)) :: A(2,2),B(2,2)
 real(kind(1d0)) :: z(2),G(2,2),sub22(2,2),w1,w2,s
 z=W(2:3,3)
 !call givens(z,G)
call slimplanerot(z,w1,w2,s)
 !sub22=G
 !G(2,:)=(G(1,1)*z(1)+G(1,2)*z(2))*sub22(1,:)
 !G(1,:)=sub22(2,:)
!G(2,1)=s*w1
!G(2,2)=s*w2
!G(1,2)=w1
!G(1,1)=-w2
 !A=transpose(G)
A(1,1)=-w2
A(1,2)=s*w1
A(2,1)=w1
A(2,2)=s*w2
 B(1,:)=W(1,1:2)
 !B(2,1)=G(1,1)*W(2,1)+G(1,2)*W(3,1)
B(2,1)=-w2*W(2,1)+w1*W(3,1)
 !B(2,2)=G(1,1)*W(2,2)+G(1,2)*W(3,2)
B(2,2)=-w2*W(2,2)+w1*W(3,2)
 return
end subroutine split2

subroutine split3wh(A,B,D)
 ! factorizes D
 implicit none
 real(kind(1d0)) :: D(4,4)
 real(kind(1d0)) :: A(3,3),B(3,3)
 real(kind(1d0)) :: v(3),M(4,4)
 v=D(1:3,1)
 call householder(A,v)  
 M(4,:)=D(4,:)
! M(1:3,:)=matmul(A,D(1:3,:))
M(1,1)=A(1,1)*D(1,1)+A(1,2)*D(2,1)+A(1,3)*D(3,1)
M(2,2)=A(2,1)*D(1,2)+A(2,2)*D(2,2)+A(2,3)*D(3,2)
M(2,3)=A(2,1)*D(1,3)+A(2,2)*D(2,3)+A(2,3)*D(3,3)
M(2,4)=A(2,1)*D(1,4)+A(2,2)*D(2,4)+A(2,3)*D(3,4)
M(3,2)=A(3,2)*D(2,2)+A(3,3)*D(3,2)
M(3,3)=A(3,2)*D(2,3)+A(3,3)*D(3,3)
M(3,4)=A(3,2)*D(2,4)+A(3,3)*D(3,4)
 if(M(1,1)>0.d0)then     ! ATTENZIONE!!!!!!!!!!!!!!!!!!!!!!!!!
   B=M(2:4,2:4)
 else
   B(1:2,:)=-M(2:3,2:4)
   B(3,:)=M(4,2:4)
   A=-A
 endif
 A=transpose(A)
 return
end subroutine split3wh

subroutine householder(A,x)
 ! computes A such that A*x=[norm(x); 0; 0].
 implicit none
 real(kind(1d0)) :: x(3)
 real(kind(1d0)) :: A(3,3),w1,w2,z1,z2
 real(kind(1d0)) :: v(2)
 !v=x
 !call slimgivens(v(2:3),w1,w2)
 !v(2)=w1*v(2)+w2*v(3)
 !call slimgivens(v(1:2),z1,z2) 
!call slimgivens(x(2:3),w1,w2)
!v(2)=w1*x(2)+w2*x(3)
!v(1)=x(1)
call slimplanerot(x(2:3),w1,w2,v(2))
v(1)=x(1)
call slimgivens(v(1:2),z1,z2) 
 A(1,1)=z1
 A(1,2)=z2*w1
 A(1,3)=z2*w2
 A(2,1)=-z2
 A(2,2)=z1*w1
 A(2,3)=z1*w2
 A(3,1)=0.d0
 A(3,2)=-w2
 A(3,3)=w1
 return
end subroutine householder

subroutine hhbulge(G,HH)
! computes G that eliminates the bulge in HH,
! where HH is 3x3
implicit none
real(kind(1d0)) :: HH(3,3)
real(kind(1d0)) :: G(3,3)
real(kind(1d0)) :: M1(3,3),xx(3),yy(2),w1,w2
xx=HH(:,1)
call householder(M1,xx)
yy(1)=M1(2,1)*HH(1,2)+M1(2,2)*HH(2,2)+M1(2,3)*HH(3,2)
yy(2)=M1(3,2)*HH(2,2)+M1(3,3)*HH(3,2)
call slimgivens(yy,w1,w2)
G(1,:)=M1(1,:)
!G(2,:)=w1*M1(2,:)+w2*M1(3,:)
G(2,1)=w1*M1(2,1)+w2*M1(3,1)
G(2,2)=w1*M1(2,2)+w2*M1(3,2)
G(2,3)=w1*M1(2,3)+w2*M1(3,3)
!G(3,:)=-w2*M1(2,:)+w1*M1(3,:)
G(3,1)=-w2*M1(2,1)+w1*M1(3,1)
G(3,2)=-w2*M1(2,2)+w1*M1(3,2)
G(3,3)=-w2*M1(2,3)+w1*M1(3,3)
return
end subroutine hhbulge

subroutine hhbulge3(G,Hleft,Hright,t)
! computes G that eliminates the bulge in Hleft
! and Hright, where H* is 3x3
implicit none
real(kind(1d0)) :: Hleft(3,3),Hright(3,3),t
real(kind(1d0)) :: G(3,3)
real(kind(1d0)) :: M1(3,3),xx(3),yy(2),nl,w1,w2
nl=abs(Hleft(1,1))+abs(Hleft(2,1))+abs(Hleft(3,1))
if (nl>t)then
xx=Hleft(:,1)
else
  xx=Hright(:,1)
endif
call householder(M1,xx)
yy(1)=M1(2,1)*Hleft(1,2)+M1(2,2)*Hleft(2,2)+M1(2,3)*Hleft(3,2)
yy(2)=M1(3,2)*Hleft(2,2)+M1(3,3)*Hleft(3,2)
if(abs(yy(1))+abs(yy(2))<t)then
yy(1)=M1(2,1)*Hright(1,2)+M1(2,2)*Hright(2,2)+M1(2,3)*Hright(3,2)
yy(2)=M1(3,2)*Hright(2,2)+M1(3,3)*Hright(3,2)
endif  
call slimgivens(yy,w1,w2)  
G(1,:)=M1(1,:)
G(2,:)=w1*M1(2,:)+w2*M1(3,:)
G(3,:)=-w2*M1(2,:)+w1*M1(3,:)
return
end subroutine hhbulge3

subroutine hhbulge4(G,Hleft,Hright,t)
! computes G that eliminates the bulge in H*,
! where H* is 4x4
implicit none
real(kind(1d0)) :: Hleft(4,4),Hright(4,4),t
real(kind(1d0)) :: G(4,4)
real(kind(1d0)) :: Al(4,4),Ar(4,4),M(2,2),y(2),sub24(2,4),sub44(4,4),nl
Al=Hleft
Ar=Hright
nl=abs(Al(1,1))+abs(Al(2,1))+abs(Al(3,1))+abs(Al(4,1))
G=0.d0
G(1,1)=1.d0
G(2,2)=1.d0
G(3,3)=1.d0
G(4,4)=1.d0
! first column
!if (nl>nr)then
if(nl>t)then
y=Al(3:4,1)
call givens(y,M)
sub24=Al(3:4,:)
Al(3:4,:)=matmul(M,sub24)
sub24=G(3:4,:)
G(3:4,:)=matmul(M,sub24)
y=Al(2:3,1)
call givens(y,M)
sub24=Al(2:3,:)
Al(2:3,:)=matmul(M,sub24)
sub24=G(2:3,:)
G(2:3,:)=matmul(M,sub24)
y=Al(1:2,1)
call givens(y,M)
sub24=Al(1:2,:)
Al(1:2,:)=matmul(M,sub24)
sub24=G(1:2,:)
G(1:2,:)=matmul(M,sub24)
sub44=Ar
Ar=matmul(G,sub44)
else
y=Ar(3:4,1)
call givens(y,M)
sub24=Ar(3:4,:)
Ar(3:4,:)=matmul(M,sub24)
sub24=G(3:4,:)
G(3:4,:)=matmul(M,sub24)
y=Ar(2:3,1)
call givens(y,M)
sub24=Ar(2:3,:)
Ar(2:3,:)=matmul(M,sub24)
sub24=G(2:3,:)
G(2:3,:)=matmul(M,sub24)
y=Ar(1:2,1)
call givens(y,M)
sub24=Ar(1:2,:)
Ar(1:2,:)=matmul(M,sub24)
sub24=G(1:2,:)
G(1:2,:)=matmul(M,sub24)
sub44=Al
Al=matmul(G,sub44)
endif
!second column
nl=abs(Al(2,2))+abs(Al(3,2))+abs(Al(4,2))
if(nl>t)then
y=Al(3:4,2)
call givens(y,M)
sub24=Al(3:4,:)
Al(3:4,:)=matmul(M,sub24)
sub24=Ar(3:4,:)
Ar(3:4,:)=matmul(M,sub24)
sub24=G(3:4,:)
G(3:4,:)=matmul(M,sub24)
y=Al(2:3,2)
call givens(y,M)
sub24=Al(2:3,:)
Al(2:3,:)=matmul(M,sub24)
sub24=Ar(2:3,:)
Ar(2:3,:)=matmul(M,sub24)
sub24=G(2:3,:)
G(2:3,:)=matmul(M,sub24)
else
y=Ar(3:4,2)
call givens(y,M)
sub24=Al(3:4,:)
Al(3:4,:)=matmul(M,sub24)
sub24=Ar(3:4,:)
Ar(3:4,:)=matmul(M,sub24)
sub24=G(3:4,:)
G(3:4,:)=matmul(M,sub24)
y=Ar(2:3,2)
call givens(y,M)
sub24=Al(2:3,:)
Al(2:3,:)=matmul(M,sub24)
sub24=Ar(2:3,:)
Ar(2:3,:)=matmul(M,sub24)
sub24=G(2:3,:)
G(2:3,:)=matmul(M,sub24)
endif
!no choice needed for third column,
!we just use Al here 
y=Al(3:4,3)
call givens(y,M)
sub24=Al(3:4,:)
Al(3:4,:)=matmul(M,sub24)
sub24=G(3:4,:)
G(3:4,:)=matmul(M,sub24)
return
end subroutine hhbulge4

subroutine split3_for_ds(A,B,C,W)
implicit none
real(kind(1d0)) :: W(4,4)
real(kind(1d0)) :: A(2,2),B(2,2),C(2,2)
real(kind(1d0)) :: x(2),Y(3,3)
x=W(1,1:2)
call givens(x,C)
Y(:,1)=W(2:4,1)*C(2,1)+W(2:4,2)*C(2,2)
Y(:,2:3)=W(2:4,3:4)
call split2(A,B,Y)
return
end subroutine split3_for_ds


subroutine split4_for_ds(A,B,C,D)
implicit none
real(kind(1d0)) :: D(5,5)
real(kind(1d0)) :: A(3,3),B(3,3),C(3,3)
real(kind(1d0)) :: aa(3),aux44(4,4)
aa=D(1:3,1)
call householder(A,aa)

aux44(1,1)=A(2,1)*D(1,2)+A(2,2)*D(2,2)+A(2,3)*D(3,2)
aux44(1,2)=A(2,1)*D(1,3)+A(2,2)*D(2,3)+A(2,3)*D(3,3)
aux44(1,3)=A(2,1)*D(1,4)+A(2,2)*D(2,4)+A(2,3)*D(3,4)
aux44(1,4)=A(2,1)*D(1,5)+A(2,2)*D(2,5)+A(2,3)*D(3,5)

aux44(2,1)=A(3,2)*D(2,2)+A(3,3)*D(3,2)
aux44(2,2)=A(3,2)*D(2,3)+A(3,3)*D(3,3)
aux44(2,3)=A(3,2)*D(2,4)+A(3,3)*D(3,4)
aux44(2,4)=A(3,2)*D(2,5)+A(3,3)*D(3,5)

aux44(3:4,:)=D(4:5,2:5)

A=transpose(A)
call split3wh(B,C,aux44)
return
end subroutine split4_for_ds
